/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __read, __spreadArray, __values } from "tslib";
import { Brush } from "igniteui-react-core";
import { XYChart } from "./XYChart";
import { IndicatorPane } from "./IndicatorPane";
import { Base, BaseError, EventArgs, runOn, delegateRemove, delegateCombine, fromEnum, typeCast, EnumUtil, Number_$type, String_$type, enumGetBox, markType, TypeRegistrar, fromEn } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { DataSeriesType_$type } from "igniteui-react-core";
import { IDataSeriesAdapterRule_$type } from "igniteui-react-core";
import { SimpleFinancialPriceSeriesRule } from "igniteui-react-core";
import { SubCollectionsRule } from "igniteui-react-core";
import { XamDataChart } from "./XamDataChart";
import { FinancialChartVolumeType_$type } from "./FinancialChartVolumeType";
import { FinancialChartXAxisMode_$type } from "./FinancialChartXAxisMode";
import { FinancialChartYAxisMode_$type } from "./FinancialChartYAxisMode";
import { FinancialChartType_$type } from "./FinancialChartType";
import { NumericYAxis } from "./NumericYAxis";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { FinancialChartZoomSliderType_$type } from "./FinancialChartZoomSliderType";
import { BrushCollection } from "igniteui-react-core";
import { FinancialChartRangeSelectorOptionCollection } from "./FinancialChartRangeSelectorOptionCollection";
import { ObservableCollection$1 } from "igniteui-react-core";
import { TemplatedHtmlControl } from "./TemplatedHtmlControl";
import { FinancialChartContext } from "./FinancialChartContext";
import { FinancialChartToolbarContext } from "./FinancialChartToolbarContext";
import { FinancialChartViewModel } from "./FinancialChartViewModel";
import { FinancialChartToolbarViewModel } from "./FinancialChartToolbarViewModel";
import { AxisDefaults } from "./AxisDefaults";
import { Defaults } from "./Defaults";
import { BrushUtil } from "igniteui-react-core";
import { Series } from "./Series";
import { Rect } from "igniteui-react-core";
import { Axis } from "./Axis";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { MarkerSeries } from "./MarkerSeries";
import { IZoomableCategoryAxis_$type } from "./IZoomableCategoryAxis";
import { SyncSettings } from "./SyncSettings";
import { SyncManager } from "./SyncManager";
import { FinancialOverlayType_$type } from "./FinancialOverlayType";
import { ArrayExtension } from "igniteui-react-core";
import { FinancialIndicatorType_$type } from "./FinancialIndicatorType";
import { IndicatorDisplayType_$type } from "./IndicatorDisplayType";
import { ITimeRangeSelectorAxis_$type } from "./ITimeRangeSelectorAxis";
import { FinancialChartVisualData } from "./FinancialChartVisualData";
import { FinancialChartCustomIndicatorArgs } from "./FinancialChartCustomIndicatorArgs";
import { ScalerParams } from "./ScalerParams";
import { stringReplace, stringJoin, stringIsNullOrEmpty } from "igniteui-react-core";
import { timeSpanFromDays } from "igniteui-react-core";
import { dateMaxValue, dateMinValue } from "igniteui-react-core";
import { isNaN_, isInfinity } from "igniteui-react-core";
import { FinancialChartTypePicker } from "./FinancialChartTypePicker";
import { FinancialChartIndicatorMenu } from "./FinancialChartIndicatorMenu";
import { TrendLineType_$type } from "igniteui-react-core";
import { FinancialChartIndicatorMenuContext } from "./FinancialChartIndicatorMenuContext";
import { FinancialChartTypePickerContext } from "./FinancialChartTypePickerContext";
import { FinancialChartRangeSelectorContext } from "./FinancialChartRangeSelectorContext";
import { FinancialChartToolbarVisualData } from "./FinancialChartToolbarVisualData";
import { FinancialChartRangeSelectorViewModel } from "./FinancialChartRangeSelectorViewModel";
import { FinancialChartRangeSelectorView } from "./FinancialChartRangeSelectorView";
/**
 * @hidden
 */
var FinancialChart = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChart, _super);
    function FinancialChart() {
        var _this = _super.call(this) || this;
        _this.ad4 = null;
        _this.ag2 = null;
        _this.ag0 = null;
        _this.agx = null;
        _this.agz = null;
        _this.ag1 = null;
        _this.agy = null;
        _this.ada = null;
        _this.ahk = null;
        _this.ahl = null;
        _this.ahh = null;
        _this.ahm = null;
        _this.ahn = null;
        _this.ahi = null;
        _this.ahj = null;
        _this.aes = null;
        _this.af2 = 40;
        _this.ady = null;
        _this.adw = null;
        _this.ad0 = null;
        _this.ad5 = null;
        _this.ahv = null;
        _this.aeo = null;
        _this.afe = false;
        _this.afd = false;
        _this.afl = false;
        _this.ae0 = false;
        _this.ag8 = 10;
        _this.af9 = NaN;
        _this.agb = NaN;
        _this.aga = NaN;
        _this.agc = 0;
        _this.adg = 0;
        _this.adj = 0;
        _this.af4 = 3;
        _this.af7 = NaN;
        _this.af5 = NaN;
        _this.af6 = NaN;
        _this.af8 = NaN;
        _this.adl = 0;
        _this.aev = true;
        _this.adc = 0;
        _this.aew = false;
        _this.adq = null;
        _this.ads = null;
        _this.afn = null;
        _this.aey = true;
        _this.aex = false;
        _this.aez = false;
        _this.aep = null;
        _this.adn = 1;
        _this.ace = null;
        _this.acf = null;
        _this.acg = null;
        _this.ach = null;
        _this.acj = null;
        _this.aci = null;
        _this.acd = null;
        _this.acc = null;
        _this.af3 = 1;
        _this.af1 = 1;
        _this.af0 = 2;
        _this.afz = 1;
        _this.ad2 = null;
        _this.ag4 = -2147483648;
        _this.afy = 2;
        _this.ag7 = 3;
        _this.ag5 = 10;
        _this.ag3 = 30;
        _this.ag6 = 9;
        _this.ac7 = null;
        _this.ac8 = null;
        _this.ac3 = null;
        _this.applyCustomIndicators = null;
        _this.alp = null;
        _this.agd = 1;
        _this.aeu = false;
        _this.adu = null;
        _this.afv = dateMinValue();
        _this.afu = dateMaxValue();
        _this.afs = null;
        _this.q8();
        _this.afs = new ObservableCollection$1(Base.$, 0);
        if (_this.xAxisBreaks != null) {
            var a = _this.xAxisBreaks;
            a.collectionChanged = delegateCombine(a.collectionChanged, function (a, b) { return _this.ale(); });
        }
        _this.akz();
        return _this;
    }
    FinancialChart.prototype.se = function (a, b, c) {
        _super.prototype.se.call(this, a, b, c);
        switch (a) {
            case "ToolbarTemplate":
            case "RangeSelectorTemplate":
                this.adb = new FinancialChartToolbar(this, this.ahs);
                break;
            case "Toolbar":
                var d = b;
                if (d != null) {
                    d.chartTypeChanged = delegateRemove(d.chartTypeChanged, runOn(this, this.akm));
                    d.trendLineTypeChanged = delegateRemove(d.trendLineTypeChanged, runOn(this, this.akp));
                    d.volumeTypeChanged = delegateRemove(d.volumeTypeChanged, runOn(this, this.akq));
                    d.l(null);
                }
                if (this.adb != null) {
                    this.adb.ac = this.adi;
                    this.adb.ai = this.di;
                    this.adb.y = this.add;
                    this.adb.al = this.afb;
                    if (this.agz != null) {
                        this.adb.l(this.agz);
                    }
                    var e = this.adb;
                    e.chartTypeChanged = delegateCombine(e.chartTypeChanged, runOn(this, this.akm));
                    ;
                    var f = this.adb;
                    f.trendLineTypeChanged = delegateCombine(f.trendLineTypeChanged, runOn(this, this.akp));
                    var g = this.adb;
                    g.volumeTypeChanged = delegateCombine(g.volumeTypeChanged, runOn(this, this.akq));
                }
                break;
            case "ChartType":
                if (this.adb != null) {
                    this.adb.y = this.add;
                }
                break;
            case "VolumeType":
                if (this.adb != null) {
                    this.adb.ac = this.adi;
                }
                break;
            case "TrendLineType":
                if (this.adb != null) {
                    this.adb.ai = this.di;
                }
                break;
            case "IsToolbarVisible":
                if (this.adb == null) {
                    break;
                }
                this.adb.al = this.afb;
                this.setGridRows();
                break;
        }
    };
    FinancialChart.prototype.akq = function (a, b) {
        this.adi = this.adb.ac;
    };
    FinancialChart.prototype.akp = function (a, b) {
        this.di = this.adb.ai;
    };
    FinancialChart.prototype.akm = function (a, b) {
        this.add = this.adb.y;
    };
    FinancialChart.prototype.akz = function () {
        this.ad4 = new IndicatorPane();
        this.adv = TypeRegistrar.create("FinancialLegend");
    };
    FinancialChart.prototype.provideGrid = function (a) {
        this.ag2 = a;
        this.alk();
        this.setGridRows();
        if (this.adb != null) {
            this.adb.bg(a);
        }
    };
    FinancialChart.prototype.onDocumentClick = function (a) {
        if (this.adb != null) {
            this.adb.bl(a);
        }
    };
    FinancialChart.prototype.getContext = function () {
        var a = this.adb.v();
        var b = new FinancialChartContext();
        b.vm = new FinancialChartViewModel();
        b.vm.toolbar = a;
        b.container = this.jt;
        b.toolbarContainer = this.agz;
        b.legendContainer = this.agy;
        b.indicatorsContainer = this.agx;
        b.volumeContainer = this.ag0;
        b.zoomContainer = this.ag1;
        return b;
    };
    FinancialChart.prototype.provideContainer = function (a) {
        var b = a;
        if (b != null) {
            var c = "financialChartMainGrid";
            var d = b.createElement("div");
            d.setStyleProperty("width", "100%");
            d.setStyleProperty("height", "100%");
            if (this.adb == null) {
                this.adb = new FinancialChartToolbar(this, this.ahs);
            }
            this.adb.w.isIndicatorMenuVisible = this.ae2 && this.ae3;
            this.agz = b.getSubRenderer(d);
            this.adb.l(this.agz);
            var e = b.createElement("div");
            e.setStyleProperty("width", "100%");
            e.setStyleProperty("height", "100%");
            var f = b.createElement("div");
            f.setStyleProperty("width", "100%");
            f.setStyleProperty("height", "100%");
            this.agy = b.getSubRenderer(f);
            var g = b.createElement("div");
            g.setStyleProperty("width", "100%");
            g.setStyleProperty("height", "100%");
            this.agx = b.getSubRenderer(g);
            var h = b.createElement("div");
            h.setStyleProperty("width", "100%");
            h.setStyleProperty("height", "100%");
            this.ag0 = b.getSubRenderer(h);
            var i = b.createElement("div");
            i.setStyleProperty("width", "100%");
            i.setStyleProperty("height", "100%");
            this.ag1 = b.getSubRenderer(i);
            a = b.getSubRenderer(e);
        }
        else {
            this.agz = null;
            if (this.adb != null) {
                this.adb.l(null);
            }
            if (this.aet != null) {
                this.aet.provideContainer(null);
                this.aet = null;
            }
            if (this.adv != null) {
                this.adv.provideContainer(null);
            }
        }
        _super.prototype.provideContainer.call(this, a);
        if (b != null) {
            if (this.volumeChart != null) {
                this.volumeChart.provideContainer(this.ag0);
            }
            if (this.ad4 != null) {
                this.ad4.h(this.agx);
            }
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.provideContainer(this.ag1);
                if (a != null) {
                    this.aj6();
                }
                else {
                    this.aet = null;
                }
            }
            if (this.adv != null) {
                this.adv.provideContainer(this.agy);
            }
            this.setGridRows();
        }
    };
    FinancialChart.prototype.ala = function (a, b, c) {
        if (a != null) {
            a.provideContainer(null);
        }
        if (b != null) {
            b.provideContainer(c);
        }
        this.setGridRows();
    };
    FinancialChart.prototype.alo = function (a, b) {
        this.ala(a, b, this.ag1);
        if (b == null) {
            return;
        }
        this.aj6();
    };
    FinancialChart.prototype.aj6 = function () {
        var _this = this;
        if (this.ag1 == null) {
            return;
        }
        if (this.aet != null) {
            this.aet.provideContainer(null);
        }
        this.aet = TypeRegistrar.create("ZoomSlider");
        this.aet.provideContainer(this.ag1);
        var a = this.aet;
        a.windowRectChanged = delegateCombine(a.windowRectChanged, function (a, b) {
            if (_this.dataChart != null) {
                _this.dataChart.tp = new Rect(0, _this.aet.windowRect.left, _this.dataChart.s9.top, _this.aet.windowRect.width, _this.dataChart.s9.height);
            }
        });
        this.aj7();
    };
    FinancialChart.prototype.alm = function (a, b) {
        this.ala(a, b, this.ag0);
    };
    FinancialChart.prototype.setGridRows = function () {
        if (this.ag2 == null) {
            return;
        }
        var a = new Array(6);
        a[0] = (this.afb ? this.agj : 0) + "px";
        a[1] = this.ae7 ? "min-content" : "0px";
        a[2] = "auto";
        a[3] = this.indicatorCharts == null || this.indicatorCharts.count == 0 ? "0px" : this.indicatorCharts.count * 150 + "px";
        a[4] = this.volumeChart == null ? "0px" : "100px";
        a[5] = this.zoomSliderChart == null ? "0px" : "100px";
        if (this.aet != null) {
            if (a[5] == "0px") {
                this.aet.hide();
            }
            else {
                this.aet.show();
            }
        }
        this.ag2.setStyleProperty("-ms-grid-rows", stringReplace(stringJoin.apply(void 0, __spreadArray([" "], __read(a), false)), "auto", "1fr"));
        this.ag2.setStyleProperty("grid-template-rows", stringJoin.apply(void 0, __spreadArray([" "], __read(a), false)));
        if (this.jt == null) {
            return;
        }
        if (this.dataChart != null) {
            this.dataChart.notifyContainerResized();
        }
        if (this.ad4 != null) {
            this.ad4.f();
        }
        if (this.volumeChart != null) {
            this.volumeChart.notifyContainerResized();
        }
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.notifyContainerResized();
        }
        if (this.aet != null) {
            this.aet.notifySizeChanged();
        }
    };
    FinancialChart.prototype.rq = function () {
        var e_1, _a;
        _super.prototype.rq.call(this);
        this.vq = 1;
        this.aa5 = 0;
        this.xn = 0;
        this.abz = null;
        this.abs = AxisDefaults.g;
        this.w7 = AxisDefaults.e;
        this.w6 = AxisDefaults.f;
        this.abt = AxisDefaults.j;
        this.abp = null;
        this.alq = AxisDefaults.h;
        this.agw = AxisDefaults.b;
        this.fi = true;
        this.fb = true;
        this.fc = false;
        this.a6 = 0;
        this.hv = Defaults.j;
        this.t0 = Defaults.ae;
        this.tv = Defaults.af;
        this.tw = Defaults.ag;
        this.ig = NaN;
        this.h7 = 40;
        this.fr = true;
        this.fx = false;
        if (this.dataChart != null) {
            var a = this.dataChart.cu.j.e();
            this.acm = a.d;
            this.acn = a.e;
            this.acl = a.d;
            this.alq = this.dataChart.xu;
        }
        var b = new BrushCollection();
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#8BDC5C";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#8961A9";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#6DB1FF";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#82E9D9";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#EA3C63";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#735656";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#F8CE4F";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#A8A8B7";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#E051A9";
            return $ret;
        })()));
        b.add(((function () {
            var $ret = new Brush();
            $ret.fill = "#FF903B";
            return $ret;
        })()));
        var c = new BrushCollection();
        try {
            for (var _b = __values(fromEnum(b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var d = _c.value;
                c.add(BrushUtil.m(d, 0.3));
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        this.aco = c;
        this.acp = b;
    };
    FinancialChart.prototype.ak6 = function () {
        if (this.ad4 != null) {
            this.ad4.b = null;
            this.ad4.b = this.indicatorCharts;
        }
        this.setGridRows();
    };
    FinancialChart.prototype.ak7 = function () {
        this.setGridRows();
    };
    FinancialChart.prototype.alg = function () {
        this.ak6();
    };
    FinancialChart.prototype.aj5 = function () {
        if (this.aet == null || this.zoomSliderChart == null || this.dataChart == null || this.dataChart.series.count == 0) {
            return;
        }
        var a = this.jt.rootWrapper.width();
        var b = this.dataChart.to.left + this.dataChart.to.width;
        var c = this.dataChart.to.left;
        var d = a - b;
        this.aet.startInset = c - this.aet.trackStartInset;
        this.aet.endInset = d - this.aet.trackEndInset;
        if (this.aet.endInset < 0) {
            var e = this.aet.endInset;
            this.aet.endInset = 0;
            this.dataChart.g1 += (e * -1);
        }
        if (this.aet.startInset < 0) {
            var f = this.aet.startInset;
            this.aet.startInset = 0;
            this.dataChart.gw += (f * -1);
        }
        this.zoomSliderChart.gw = c;
        this.zoomSliderChart.g1 = d;
        this.zoomSliderChart.gj = this.aet.barExtent;
    };
    FinancialChart.prototype.akw = function () {
        this.aj5();
    };
    FinancialChart.prototype.rn = function (a) {
        _super.prototype.rn.call(this, a);
        if (a != null) {
            a.gi = 0;
        }
    };
    FinancialChart.prototype.alr = function (a) {
        return a.s2();
    };
    FinancialChart.prototype.alu = function () {
        return this.agy == null ? null : this.alt(this.agy.rootWrapper);
    };
    FinancialChart.prototype.als = function (a) {
        if (a == null || a.d == null) {
            return null;
        }
        return this.alt(a.d.rootWrapper);
    };
    FinancialChart.prototype.alt = function (a) {
        if (a == null) {
            return null;
        }
        var b = a.getOffset();
        return new Rect(0, b.left, b.top, a.width(), a.height());
    };
    FinancialChart.prototype.age = function () {
        if (this.ag2 == null) {
            return NaN;
        }
        var a = this.ag2.getOffset();
        return this.ag2.width() + (a == null ? 0 : a.left);
    };
    FinancialChart.prototype.ry = function (source_, a, b) {
        _super.prototype.ry.call(this, source_, a, b);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.mg(source_, a, b);
        }
    };
    FinancialChart.prototype.rz = function (source_, a, b) {
        _super.prototype.rz.call(this, source_, a, b);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.mh(source_, a, b);
        }
    };
    FinancialChart.prototype.rx = function (source_) {
        _super.prototype.rx.call(this, source_);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.l9(source_);
        }
    };
    FinancialChart.prototype.r1 = function (source_, a, b, c) {
        _super.prototype.r1.call(this, source_, a, b, c);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.mi(source_, a, b, c);
        }
    };
    FinancialChart.prototype.rt = function (a, b) {
        _super.prototype.rt.call(this, a, b);
        if (this.ae8(a)) {
            a.toolTip = null;
        }
    };
    Object.defineProperty(FinancialChart.prototype, "adb", {
        get: function () {
            return this.ada;
        },
        set: function (a) {
            var b = this.adb;
            if (a != b) {
                this.ada = a;
                this.sc("Toolbar", b, this.adb);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahr", {
        get: function () {
            return this.ahk;
        },
        set: function (a) {
            var b = this.ahr;
            if (a != b) {
                this.ahk = a;
                this.sc("RangeSelectorTemplate", b, this.ahr);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahs", {
        get: function () {
            return this.ahl;
        },
        set: function (a) {
            var b = this.ahs;
            if (a != b) {
                this.ahl = a;
                this.sc("ToolbarTemplate", b, this.ahs);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aho", {
        get: function () {
            return this.ahh;
        },
        set: function (a) {
            var b = this.aho;
            if (a != b) {
                this.ahh = a;
                this.sc("ChartTypePickerTemplate", b, this.aho);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aht", {
        get: function () {
            return this.ahm;
        },
        set: function (a) {
            var b = this.aht;
            if (a != b) {
                this.ahm = a;
                this.sc("TrendLineTypePickerTemplate", b, this.aht);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahu", {
        get: function () {
            return this.ahn;
        },
        set: function (a) {
            var b = this.ahu;
            if (a != b) {
                this.ahn = a;
                this.sc("VolumeTypePickerTemplate", b, this.ahu);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahp", {
        get: function () {
            return this.ahi;
        },
        set: function (a) {
            var b = this.ahp;
            if (a != b) {
                this.ahi = a;
                this.sc("IndicatorMenuTemplate", b, this.ahp);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahq", {
        get: function () {
            return this.ahj;
        },
        set: function (a) {
            var b = this.ahq;
            if (a != b) {
                this.ahj = a;
                this.sc("OverlayPickerTemplate", b, this.ahq);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aet", {
        get: function () {
            return this.aes;
        },
        set: function (a) {
            var b = this.aet;
            if (a != b) {
                this.aes = a;
                this.sc("ZoomSlider", b, this.aet);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.get_h7 = function () {
        return _super.prototype.get_h7.call(this);
    };
    FinancialChart.prototype.set_h7 = function (a) {
        _super.prototype.set_h7.call(this, a);
    };
    FinancialChart.prototype.get_fr = function () {
        return _super.prototype.get_fr.call(this);
    };
    FinancialChart.prototype.set_fr = function (a) {
        _super.prototype.set_fr.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "agj", {
        get: function () {
            return this.af2;
        },
        set: function (a) {
            var b = this.agj;
            if (a != b) {
                this.af2 = a;
                this.sc("ToolbarHeight", b, this.agj);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.vf = function () {
        return this.xAxis;
    };
    FinancialChart.prototype.vg = function () {
        return this.yAxis;
    };
    FinancialChart.prototype.onAttachedToUI = function () {
        _super.prototype.onAttachedToUI.call(this);
        if (this.aet != null) {
            this.aet.onAttachedToUI();
        }
    };
    FinancialChart.prototype.onDetachedFromUI = function () {
        _super.prototype.onDetachedFromUI.call(this);
        if (this.aet != null) {
            this.aet.onDetachedFromUI();
        }
    };
    FinancialChart.prototype.a9 = function (a) {
        return 20;
    };
    FinancialChart.prototype.get_ge = function () {
        return ((function () {
            var $ret = new List$1(DataSeriesType_$type, 0);
            $ret.add(20);
            return $ret;
        })());
    };
    Object.defineProperty(FinancialChart.prototype, "ge", {
        get: function () {
            return this.get_ge();
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.get_gd = function () {
        return ((function () {
            var $ret = new List$1(IDataSeriesAdapterRule_$type, 0);
            $ret.add(new SimpleFinancialPriceSeriesRule());
            $ret.add(new SubCollectionsRule());
            return $ret;
        })());
    };
    Object.defineProperty(FinancialChart.prototype, "gd", {
        get: function () {
            return this.get_gd();
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.acx = function (a) {
        return this.acy(a);
    };
    FinancialChart.prototype.aeb = function (a) {
        return this.aec(a);
    };
    FinancialChart.prototype.acw = function (a) {
        var b = this.acx(0);
        b.name = a;
        return b;
    };
    FinancialChart.prototype.q4 = function () {
        this.xAxis = this.acw("xAxis");
        this.yAxis = this.aeb(0);
        this.yAxis.name = "yAxis";
        this.volumeAxis = this.aeb(0);
        this.volumeAxis.name = "volumeAxis";
        this.volumeXAxis = this.acw("volumeXAxis");
        this.afp = new List$1(NumericYAxis.$, 0);
        this.afr = new List$1(CategoryAxisBase.$, 0);
        this.indicatorAxis = this.aeb(0);
        this.indicatorAxis.name = "indicatorAxis";
        this.indicatorXAxis = this.acw("indicatorXAxis_0");
        this.afp.add(this.indicatorAxis);
        this.afr.add(this.indicatorXAxis);
        if (this.xAxis.ay == null) {
            this.xAxis.ay = new AxisLabelSettings();
        }
        if (this.yAxis.ay == null) {
            this.yAxis.ay = new AxisLabelSettings();
        }
        if (this.volumeAxis.ay == null) {
            this.volumeAxis.ay = new AxisLabelSettings();
        }
        if (this.volumeXAxis.ay == null) {
            this.volumeAxis.ay = new AxisLabelSettings();
        }
        if (this.indicatorAxis.ay == null) {
            this.indicatorAxis.ay = new AxisLabelSettings();
        }
        if (this.indicatorXAxis.ay == null) {
            this.indicatorXAxis.ay = new AxisLabelSettings();
        }
        this.zoomSliderAxis = this.aeb(0);
        this.zoomSliderAxis.name = "zoomSliderAxis";
        this.zoomSliderXAxis = this.acw("zoomSliderXAxis");
        if (this.zoomSliderAxis.ay == null) {
            this.zoomSliderAxis.ay = new AxisLabelSettings();
        }
        if (this.zoomSliderXAxis.ay == null) {
            this.zoomSliderXAxis.ay = new AxisLabelSettings();
        }
    };
    FinancialChart.prototype.q0 = function (a, b) {
        var c = typeCast(MarkerSeries.$, a);
        if (c != null) {
            c.qh = this.cm(a, b);
        }
    };
    FinancialChart.prototype.cl = function (a) {
        if (a != null) {
            return 1;
        }
        return _super.prototype.cl.call(this, a);
    };
    FinancialChart.prototype.su = function (a) {
        if (a.suggestedSecondaryAxis == 2) {
            this.yAxis.lg = true;
            this.yAxis.l7 = 10;
        }
    };
    FinancialChart.prototype.sx = function () {
        this.yAxis.lg = this.afi;
        this.yAxis.l7 = this.ahg;
    };
    FinancialChart.prototype.adf = function (a) {
        var b;
        if (this.add == 0) {
            if (a == null || a.index > 0 || stringIsNullOrEmpty(a.getMemberPathFor(12))) {
                b = 4;
            }
            else {
                b = 2;
            }
        }
        else {
            b = this.add;
        }
        b = this.ade(b);
        return b;
    };
    FinancialChart.prototype.ade = function (a) {
        if ((a == 1 || a == 2)) {
            if (TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                return a;
            }
            a = 4;
        }
        if (a == 4) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 3;
        }
        if (a == 3) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    };
    FinancialChart.prototype.ado = function (a) {
        if ((a == 2 || a == 3)) {
            if (TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                return a;
            }
            a = 5;
        }
        if (a == 5) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 6;
        }
        if (a == 6) {
            if (TypeRegistrar.isRegistered("AreaSeries")) {
                return a;
            }
            a = 4;
        }
        if (a == 4) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    };
    FinancialChart.prototype.adh = function (a) {
        if (a == 2) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 3;
        }
        if (a == 3) {
            if (TypeRegistrar.isRegistered("AreaSeries")) {
                return a;
            }
            a = 1;
        }
        if (a == 1) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    };
    FinancialChart.prototype.ah3 = function (a) {
        var b = a.getMemberPathFor(14);
        if (stringIsNullOrEmpty(b)) {
            b = a.getMemberPathFor(11);
        }
        return b;
    };
    FinancialChart.prototype.acy = function (axisType_) {
        if ((this.externalObject)) {
            return (this.externalObject.createXAxis(axisType_).i);
        }
        else {
            var a = void 0;
            switch (axisType_) {
                case 0:
                    if (TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                        a = TypeRegistrar.create("OrdinalTimeXAxis");
                    }
                    else if (TypeRegistrar.isRegistered("TimeXAxis")) {
                        a = TypeRegistrar.create("TimeXAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
                case 1:
                    if (TypeRegistrar.isRegistered("TimeXAxis")) {
                        a = TypeRegistrar.create("TimeXAxis");
                    }
                    else if (TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                        a = TypeRegistrar.create("OrdinalTimeXAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
            }
            return null;
        }
    };
    FinancialChart.prototype.aec = function (axisType_) {
        if ((this.externalObject)) {
            return (this.externalObject.createYAxis(axisType_).i);
        }
        else {
            var a = void 0;
            switch (axisType_) {
                case 0:
                    if (TypeRegistrar.isRegistered("NumericYAxis")) {
                        a = TypeRegistrar.create("NumericYAxis");
                    }
                    else if (TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                        a = TypeRegistrar.create("PercentChangeYAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
                case 1:
                    if (TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                        a = TypeRegistrar.create("PercentChangeYAxis");
                    }
                    else if (TypeRegistrar.isRegistered("NumericYAxis")) {
                        a = TypeRegistrar.create("NumericYAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
            }
            return null;
        }
    };
    FinancialChart.prototype.aei = function () {
        return this.cw(1);
    };
    FinancialChart.prototype.aej = function () {
        return this.cw(0);
    };
    FinancialChart.prototype.aeh = function () {
        return this.cw(2);
    };
    FinancialChart.prototype.aek = function () {
        return this.cw(20);
    };
    Object.defineProperty(FinancialChart.prototype, "ae1", {
        get: function () {
            return (TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy"));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "adz", {
        get: function () {
            if (TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy")) {
                return TypeRegistrar.create("HorizontalAnchoredCategorySeriesProxy");
            }
            else {
                throw new BaseError(1, "horizontal series module is not loaded, but is required.");
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ae4", {
        get: function () {
            return (TypeRegistrar.isRegistered("FinancialPriceSeriesProxy"));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "adx", {
        get: function () {
            if (TypeRegistrar.isRegistered("FinancialPriceSeriesProxy")) {
                return TypeRegistrar.create("FinancialPriceSeriesProxy");
            }
            else {
                throw new BaseError(1, "financial series module is not loaded, but is required.");
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ae2", {
        get: function () {
            return (TypeRegistrar.isRegistered("IndicatorProxy"));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ad1", {
        get: function () {
            if (TypeRegistrar.isRegistered("IndicatorProxy")) {
                return TypeRegistrar.create("IndicatorProxy");
            }
            else {
                throw new BaseError(1, "financial series module is not loaded, but is required.");
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ae3", {
        get: function () {
            return (TypeRegistrar.isRegistered("OverlayProxy"));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ad6", {
        get: function () {
            if (TypeRegistrar.isRegistered("OverlayProxy")) {
                return TypeRegistrar.create("OverlayProxy");
            }
            else {
                throw new BaseError(1, "overlay series module is not loaded, but is required.");
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.cv = function (a, b) {
        var c = this.ah3(a);
        switch (this.adf(a)) {
            case 3:
                var d = this.aei();
                this.adz.setValueMemberPath(d, c);
                this.adz.setXAxis(d, this.xAxis);
                this.adz.setYAxis(d, this.yAxis);
                this.adz.setCategoryMode(d, 1);
                return d;
            case 4:
                var e = this.aej();
                this.adz.setValueMemberPath(e, c);
                this.adz.setXAxis(e, this.xAxis);
                this.adz.setYAxis(e, this.yAxis);
                this.adz.setCategoryMode(e, 1);
                return e;
            default:
            case 1:
            case 2:
                var f = this.aek();
                this.adx.setOpenMemberPath(f, a.getMemberPathFor(11));
                this.adx.setHighMemberPath(f, a.getMemberPathFor(12));
                this.adx.setLowMemberPath(f, a.getMemberPathFor(13));
                this.adx.setCloseMemberPath(f, a.getMemberPathFor(14));
                this.adx.setVolumeMemberPath(f, a.getMemberPathFor(15));
                this.adx.setXAxis(f, this.xAxis);
                this.adx.setYAxis(f, this.yAxis);
                this.adx.setDisplayType(f, this.add == 1 ? 1 : 0);
                this.adx.setCategoryMode(f, 1);
                return f;
        }
    };
    FinancialChart.prototype.sw = function () {
        _super.prototype.sw.call(this);
        this.aku(this.xAxis);
        this.ali(false);
        if (this.adi != 0 && this.volumeChart != null) {
            this.ak1();
        }
        this.aku(this.volumeXAxis);
        this.aku(this.indicatorXAxis);
        this.alf();
        this.alh();
        if (this.adp != 0) {
            this.ak2();
            this.aku(this.zoomSliderXAxis);
        }
    };
    FinancialChart.prototype.aar = function (a, b) {
        var e_2, _a;
        _super.prototype.aar.call(this, a, b);
        a(this.volumeXAxis);
        if (this.afr != null) {
            try {
                for (var _b = __values(fromEnum(this.afr)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    a(c);
                }
            }
            catch (e_2_1) {
                e_2 = { error: e_2_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_2)
                        throw e_2.error;
                }
            }
        }
        var d = true;
        switch (b) {
            case "XAxisMajorStroke":
            case "XAxisMajorStrokeThickness":
                d = false;
                break;
        }
        if (d) {
            a(this.zoomSliderXAxis);
        }
    };
    FinancialChart.prototype.aaw = function (a, b) {
        var e_3, _a;
        _super.prototype.aaw.call(this, a, b);
        if (b) {
            a(this.volumeAxis);
            if (this.afp != null) {
                try {
                    for (var _b = __values(fromEnum(this.afp)), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var c = _c.value;
                        a(c);
                    }
                }
                catch (e_3_1) {
                    e_3 = { error: e_3_1 };
                }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return))
                            _a.call(_b);
                    }
                    finally {
                        if (e_3)
                            throw e_3.error;
                    }
                }
            }
            a(this.zoomSliderAxis);
        }
    };
    FinancialChart.prototype.aky = function (a) {
        var b = typeCast(IZoomableCategoryAxis_$type, this.xAxis);
        if (b != null) {
            a(b);
        }
    };
    FinancialChart.prototype.aau = function (a) {
        _super.prototype.aau.call(this, a);
        this.aal(this.volumeXAxis, a);
        this.aal(this.indicatorXAxis, a);
        this.aal(this.zoomSliderXAxis, a);
    };
    FinancialChart.prototype.aaz = function (a) {
        _super.prototype.aaz.call(this, a);
        this.aal(this.volumeAxis, a);
        this.aal(this.indicatorAxis, a);
        this.aal(this.zoomSliderAxis, a);
    };
    FinancialChart.prototype.aax = function (a) {
        _super.prototype.aax.call(this, a);
        this.aak(this.volumeAxis, a);
        this.aak(this.indicatorAxis, a);
        this.aak(this.zoomSliderAxis, a);
    };
    FinancialChart.prototype.aas = function (a) {
        _super.prototype.aas.call(this, a);
        this.aak(this.volumeXAxis, a);
        this.aak(this.indicatorXAxis, a);
        this.aak(this.zoomSliderXAxis, a);
    };
    FinancialChart.prototype.rm = function (a) {
        var _this = this;
        _super.prototype.rm.call(this, a);
        if (a == null) {
            return;
        }
        if (a == this.zoomSliderChart) {
            a.uk = a.un = false;
            a.legend = null;
            if (this.dataChart != null) {
                a.ag = this.dataChart.ag;
                a.aj = this.dataChart.aj;
            }
        }
        else {
            SyncManager.d(a, ((function () {
                var $ret = new SyncSettings();
                $ret.syncChannel = _this.aiy();
                $ret.synchronizeHorizontally = true;
                $ret.synchronizeVertically = false;
                return $ret;
            })()));
            SyncManager.c(a);
        }
        a.ci = 2;
    };
    FinancialChart.prototype.aiy = function () {
        if (this.ahv == null) {
            FinancialChart.ahf++;
            this.ahv = FinancialChart.ahf.toString();
        }
        return this.ahv;
    };
    FinancialChart.prototype.akg = function (a, b) {
        this.aj2();
        this.akw();
    };
    FinancialChart.prototype.aj2 = function () {
        var e_4, _a;
        if (this.yAxis.b7()) {
            return;
        }
        var a = this.yAxis.av.bd;
        if (this.adi != 0) {
            a = Math.max(a, this.volumeAxis.av.bd);
        }
        try {
            for (var _b = __values(fromEnum(this.afp)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                a = Math.max(a, b.av.bd);
            }
        }
        catch (e_4_1) {
            e_4 = { error: e_4_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_4)
                    throw e_4.error;
            }
        }
        this.aj3(a);
    };
    FinancialChart.prototype.aj3 = function (a) {
        var e_5, _a;
        if (this.yAxis.b7()) {
            return;
        }
        this.yAxis.er = this.volumeAxis.er = a;
        try {
            for (var _b = __values(fromEnum(this.afp)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                b.er = a;
            }
        }
        catch (e_5_1) {
            e_5 = { error: e_5_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_5)
                    throw e_5.error;
            }
        }
        this.zoomSliderAxis.er = this.yAxis.er;
    };
    FinancialChart.prototype.aj8 = function (a) {
        if (this.indicatorCharts == null) {
            return;
        }
        for (var b = 0; b < this.indicatorCharts.count; b++) {
            var c = this.indicatorCharts._inner[b];
            for (var d = 0; d < c.series.count; d++) {
                var e = c.series._inner[d];
                if (!(this.ae6(e))) {
                    continue;
                }
                a(c.series._inner[d], b);
            }
        }
    };
    FinancialChart.prototype.akb = function (a) {
        if (this.volumeChart == null) {
            return;
        }
        for (var b = 0; b < this.volumeChart.series.count; b++) {
            var c = this.volumeChart.series._inner[b];
            if (c.dc) {
                continue;
            }
            a(this.volumeChart.series._inner[b], b);
        }
    };
    FinancialChart.prototype.aj9 = function (a) {
        if (this.dataChart == null) {
            return;
        }
        for (var b = 0; b < this.dataChart.series.count; b++) {
            var c = this.dataChart.series._inner[b];
            if (!this.ae8(c)) {
                continue;
            }
            a(c, b);
        }
    };
    FinancialChart.prototype.aka = function (a, b) {
        if (this.dataChart == null) {
            return;
        }
        for (var c = 0; c < this.dataChart.series.count; c++) {
            var d = this.dataChart.series._inner[c];
            if (this.ae8(d)) {
                continue;
            }
            var e = this.ag9(d, c);
            a(d, e);
        }
        if (b) {
            this.akc(a);
        }
    };
    FinancialChart.prototype.akc = function (a) {
        if (this.zoomSliderChart == null) {
            return;
        }
        for (var b = 0; b < this.zoomSliderChart.series.count; b++) {
            var c = this.zoomSliderChart.series._inner[b];
            if (c.dc) {
                continue;
            }
            a(this.zoomSliderChart.series._inner[b], b);
        }
    };
    FinancialChart.prototype.ag9 = function (a, b) {
        if (a.cb != this.dataChart) {
            return b;
        }
        var c = this.ba == null || this.ba.dataSeries == null ? 0 : this.ba.dataSeries.count;
        var d = this.adt == null ? 0 : this.adt.count;
        return b - (c * d);
    };
    FinancialChart.prototype.rc = function (a) {
        _super.prototype.rc.call(this, a);
        this.akb(a);
        this.aj8(a);
        this.akc(a);
    };
    Object.defineProperty(FinancialChart.prototype, "volumeChart", {
        get: function () {
            return this.aeo;
        },
        set: function (a) {
            var b = this.volumeChart;
            if (a != b) {
                this.aeo = a;
                this.sc("VolumeChart", b, this.volumeChart);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.ak1 = function () {
        if (this.dataChart == null) {
            return;
        }
        this.volumeChart.series.clear();
        var a = new List$1(Series.$, 0);
        var b = -1;
        for (var c = 0; c < this.dataChart.series.count; c++) {
            var d = this.dataChart.series._inner[c];
            if (this.ae8(d) || d.dc) {
                continue;
            }
            b++;
            var e = void 0;
            var f = this.adi;
            f = this.adh(f);
            switch (f) {
                case 2:
                    e = this.aej();
                    break;
                case 3:
                    e = this.aeh();
                    break;
                default:
                case 1:
                    e = this.aei();
                    break;
            }
            this.adz.setCategoryMode(e, 1);
            e.name = "volumeSeries_" + b;
            e.itemsSource = d.itemsSource;
            this.adz.setXAxis(e, this.volumeXAxis);
            this.adz.setYAxis(e, this.volumeAxis);
            this.adz.setValueMemberPath(e, this.ba != null && this.ba.dataSeries != null && this.ba.dataSeries.count > b ? this.ba.dataSeries._inner[b].getMemberPathFor(15) : null);
            e.title = d.title + " Volume";
            e.o7 = ArrayExtension.getModulus$1(Brush.$, this.acq, b);
            e.pc = ArrayExtension.getModulus$1(Brush.$, this.acr, b);
            e.g1 = this.agk;
            a.add(e);
        }
        var g = this.ga("volume", false);
        if (g != null) {
            a.o(g);
        }
        for (var h = 0; h < a.count; h++) {
            var i = a._inner[h];
            this.volumeChart.series.add(i);
            this.rr(i, h);
        }
    };
    FinancialChart.prototype.ae5 = function (a) {
        if (!this.ae1) {
            return false;
        }
        return this.adz.matchesType(a);
    };
    FinancialChart.prototype.ae9 = function (a) {
        if (!this.ae4) {
            return false;
        }
        return this.adx.matchesType(a);
    };
    FinancialChart.prototype.ae6 = function (a) {
        if (!this.ae2) {
            return false;
        }
        return this.ad1.matchesType(a);
    };
    FinancialChart.prototype.ae8 = function (a) {
        if (!this.ae3) {
            return false;
        }
        return this.ad6.matchesType(a);
    };
    FinancialChart.prototype.ak0 = function () {
        if (this.dataChart == null) {
            return;
        }
        var a = 0;
        var b = this.adr == null ? 0 : this.adr.count;
        var c = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
        var d = b + c;
        for (var e = 0; e < d; e++) {
            var f = new List$1(Series.$, 0);
            var g = this.indicatorCharts._inner[e];
            var h = e >= b;
            var i = h ? this.customIndicatorNames._inner[e - b] : EnumUtil.getName(FinancialIndicatorType_$type, this.adr._inner[e]);
            var j = -1;
            for (var k = 0; k < this.dataChart.series.count; k++) {
                var l = this.dataChart.series._inner[k];
                if (this.ae8(l) || l.dc) {
                    continue;
                }
                j++;
                var m = void 0;
                if (h) {
                    var n = this.ael("Custom");
                    this.ad1.handleCustomIndicatorEvent(n, runOn(this, this.ake));
                    m = n;
                }
                else {
                    m = this.aen(this.adr._inner[e]);
                }
                if (m == null) {
                    continue;
                }
                m.name = "indicator_" + a++;
                this.ad1.setXAxis(m, this.afr._inner[e]);
                this.ad1.setYAxis(m, this.afp._inner[e]);
                m.itemsSource = l.itemsSource;
                this.ad1.setOpenMemberPath(m, this.ba.dataSeries._inner[j].getMemberPathFor(11));
                this.ad1.setHighMemberPath(m, this.ba.dataSeries._inner[j].getMemberPathFor(12));
                this.ad1.setLowMemberPath(m, this.ba.dataSeries._inner[j].getMemberPathFor(13));
                this.ad1.setCloseMemberPath(m, this.ba.dataSeries._inner[j].getMemberPathFor(14));
                this.ad1.setVolumeMemberPath(m, this.ba.dataSeries._inner[j].getMemberPathFor(15));
                m.title = l.title + " " + i;
                m.o7 = ArrayExtension.getModulus$1(Brush.$, this.ack, e);
                m.g1 = this.agg;
                if (this.ae6(m)) {
                    this.ad1.setNegativeBrush(m, ArrayExtension.getModulus$1(Brush.$, this.acl, e));
                    this.ad1.setDisplayType(m, ArrayExtension.getModulus$1(IndicatorDisplayType_$type, this.ad3, e));
                }
                if (this.ahb != -2147483648 && this.ae6(m)) {
                    this.ad1.setPeriodOverride(m, this.ahb);
                }
                if (this.ae6(m)) {
                    this.ad1.setSmoothingPeriod(m, this.ahe);
                }
                if (this.ae6(m)) {
                    this.ad1.setSignalPeriod(m, this.ahd);
                }
                if (this.ae6(m)) {
                    this.ad1.setShortPeriod(m, this.ahc);
                    this.ad1.setLongPeriod(m, this.aha);
                }
                this.rr(m, e);
                f.add(m);
            }
            var o = this.ga(i, false);
            for (var p = 0; p < f.count; p++) {
                var q = f._inner[p];
                g.series.add(q);
            }
            if (o != null) {
                for (var r = 0; r < o.count; r++) {
                    var s = o._inner[r];
                    g.series.add(s);
                    this.rr(s, r);
                }
            }
        }
    };
    FinancialChart.prototype.ael = function (indicatorName_) {
        return (this.externalObject.createIndicator(indicatorName_ + 'Indicator').i);
    };
    FinancialChart.prototype.aen = function (a) {
        return this.ael(EnumUtil.getName(FinancialIndicatorType_$type, a));
    };
    FinancialChart.prototype.ali = function (a) {
        if (this.adb == null) {
            return;
        }
        var b = this.xAxis;
        if (b.actualMinimumValue > b.actualMaximumValue) {
            return;
        }
        this.adb.as = b.actualMinimumValue;
        this.adb.ar = b.actualMaximumValue;
        if (a) {
            this.adb.au = b.visibleMinimum;
            this.adb.at = b.visibleMaximum;
        }
        this.adb.bn();
    };
    FinancialChart.prototype.ju = function () {
        var e_6, _a, e_7, _b;
        var _this = this;
        var a = ((function () {
            var $ret = new FinancialChartVisualData();
            $ret.mainChart = _super.prototype.ju.call(_this);
            $ret.volumeChart = _this.volumeChart == null ? null : _this.volumeChart.vw();
            $ret.toolbar = _this.adb == null ? null : _this.adb.aj();
            $ret.zoomChart = _this.zoomSliderChart == null ? null : _this.zoomSliderChart.vw();
            return $ret;
        })());
        if (this.indicatorCharts != null) {
            a.indicatorCharts = new List$1(Base.$, 0);
            try {
                for (var _c = __values(fromEnum(this.indicatorCharts)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var b = _d.value;
                    a.indicatorCharts.add1(b.vw());
                }
            }
            catch (e_6_1) {
                e_6 = { error: e_6_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_6)
                        throw e_6.error;
                }
            }
        }
        if (this.dataChart != null) {
            a.mainChartLeft = this.alr(this.dataChart).x;
            a.mainChartTop = this.alr(this.dataChart).y;
        }
        if (this.volumeChart != null) {
            a.volumeChartLeft = this.alr(this.volumeChart).x;
            a.volumeChartTop = this.alr(this.volumeChart).y;
        }
        if (this.zoomSliderChart != null) {
            a.zoomChartLeft = this.alr(this.zoomSliderChart).x;
            a.zoomChartTop = this.alr(this.zoomSliderChart).y;
        }
        if (this.adb != null) {
            var c = this.als(this.adb);
            a.toolbarLeft = c.left;
            a.toolbarTop = c.top;
            a.toolbarWidth = c.width;
            a.toolbarHeight = c.height;
        }
        if (this.indicatorCharts != null) {
            a.indicatorChartLefts = new List$1(Number_$type, 0);
            a.indicatorChartTops = new List$1(Number_$type, 0);
            try {
                for (var _e = __values(fromEnum(this.indicatorCharts)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var d = _f.value;
                    a.indicatorChartLefts.add(this.alr(d).x);
                    a.indicatorChartTops.add(this.alr(d).y);
                }
            }
            catch (e_7_1) {
                e_7 = { error: e_7_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_7)
                        throw e_7.error;
                }
            }
        }
        var e = this.alu();
        a.legendLeft = e.left;
        a.legendTop = e.top;
        a.legendWidth = e.width;
        a.legendHeight = e.height;
        a.legend = this.adv == null ? null : this.adv.exportVisualData();
        return a;
    };
    FinancialChart.prototype.ah0 = function () {
        var a = this.ju();
        a.scaleByViewport();
        return a.serialize();
    };
    FinancialChart.prototype.aem = function (overlayName_) {
        return (this.externalObject.createOverlay(overlayName_ + 'Overlay').i);
    };
    FinancialChart.prototype.alh = function () {
        var e_8, _a, e_9, _b;
        if (this.dataChart == null) {
            return;
        }
        var a = new List$1(Series.$, 0);
        try {
            for (var _c = __values(fromEnum(this.dataChart.series)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var b = _d.value;
                if (this.ae8(b)) {
                    a.add(b);
                }
            }
        }
        catch (e_8_1) {
            e_8 = { error: e_8_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_8)
                    throw e_8.error;
            }
        }
        try {
            for (var _e = __values(fromEnum(a)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var c = _f.value;
                this.dataChart.series.remove(c);
            }
        }
        catch (e_9_1) {
            e_9 = { error: e_9_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_9)
                    throw e_9.error;
            }
        }
        if (this.adt == null) {
            return;
        }
        var d = new List$1(Series.$, 0);
        var e = -1;
        for (var f = 0; f < this.dataChart.series.count; f++) {
            var g = this.dataChart.series._inner[f];
            if (this.ae8(g) || g.dc) {
                continue;
            }
            e++;
            for (var h = 0; h < this.adt.count; h++) {
                var i = this.adt._inner[h];
                var j = void 0;
                switch (i) {
                    case 1:
                        j = this.aem(EnumUtil.getName(FinancialOverlayType_$type, i));
                        break;
                    default:
                    case 0:
                        j = this.aem(EnumUtil.getName(FinancialOverlayType_$type, i));
                        break;
                }
                j.name = g.name + "_" + EnumUtil.getName(FinancialOverlayType_$type, i);
                this.ad6.setXAxis(j, this.xAxis);
                this.ad6.setYAxis(j, this.yAxis);
                j.itemsSource = g.itemsSource;
                var k = e * this.adt.count + h;
                j.o7 = ArrayExtension.getModulus$1(Brush.$, this.aco, k);
                j.pc = ArrayExtension.getModulus$1(Brush.$, this.acp, k);
                j.g1 = this.agi;
                j.title = g.title + " " + EnumUtil.getName(FinancialOverlayType_$type, i);
                var l = g;
                if (l == null) {
                    continue;
                }
                var m = this.ba.dataSeries._inner[e];
                this.ad6.setOpenMemberPath(j, m.getMemberPathFor(11));
                this.ad6.setHighMemberPath(j, m.getMemberPathFor(12));
                this.ad6.setLowMemberPath(j, m.getMemberPathFor(13));
                this.ad6.setCloseMemberPath(j, m.getMemberPathFor(14));
                this.ad6.setVolumeMemberPath(j, m.getMemberPathFor(15));
                d.add(j);
            }
        }
        var n = new Array(this.dataChart.series.count);
        this.dataChart.series.copyTo(n, 0);
        this.dataChart.skipDataCleanup = true;
        this.dataChart.series.clear();
        this.dataChart.skipDataCleanup = false;
        for (var o = 0; o < n.length; o++) {
            n[o].index = -1;
        }
        d.o(n);
        for (var p = 0; p < d.count; p++) {
            var q = d._inner[p];
            this.dataChart.series.add(q);
            this.rr(q, p);
        }
    };
    FinancialChart.prototype.alf = function () {
        var e_10, _a;
        if (this.afe) {
            return;
        }
        this.afe = true;
        if (this.indicatorCharts != null) {
            var a = this.indicatorCharts;
            this.indicatorCharts = null;
            try {
                for (var _b = __values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    this.akv(b);
                }
            }
            catch (e_10_1) {
                e_10 = { error: e_10_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_10)
                        throw e_10.error;
                }
            }
        }
        if ((this.adr == null || this.adr.count == 0) && (this.customIndicatorNames == null || this.customIndicatorNames.count == 0)) {
            this.indicatorCharts = null;
            if (this.afp != null) {
                this.afp.clear();
            }
            if (this.afr != null) {
                this.afr.clear();
            }
            this.ak6();
            this.alg();
            this.afe = false;
            return;
        }
        if (this.indicatorCharts == null) {
            this.indicatorCharts = new List$1(XamDataChart.$, 0);
        }
        this.indicatorCharts.clear();
        this.afp.clear();
        this.afr.clear();
        var c = this.adr == null ? 0 : this.adr.count;
        var d = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
        var e = c + d;
        for (var f = 0; f < e; f++) {
            var g = new XamDataChart();
            this.indicatorCharts.add(g);
            this.akt(g);
            var h = f >= c;
            if (h) {
                g.kg = this.customIndicatorNames._inner[f - c];
            }
            else {
                g.kg = this.ah2(this.adr._inner[f]);
            }
            if (this.indicatorAxis != null) {
                var i = void 0;
                var j = void 0;
                if (f == 0) {
                    i = this.indicatorAxis;
                    j = this.indicatorXAxis;
                }
                else {
                    i = new NumericYAxis();
                    if (!this.indicatorXAxis.cd) {
                        j = this.acx(0);
                    }
                    else {
                        j = this.acx(1);
                    }
                }
                j.name = "indicatorXAxis_" + f;
                i.name = "indicatorAxis_" + f;
                g.axes.add(i);
                g.axes.add(j);
                this.afp.add(i);
                this.afr.add(j);
                if (this.e8) {
                    this.aao(i);
                }
                if (this.e8) {
                    this.aam(j);
                }
            }
        }
        this.ak0();
        this.ak6();
        if (this.adb != null) {
            this.adb.ae = this.adr;
        }
        this.aj4();
        this.alg();
        this.afe = false;
    };
    FinancialChart.prototype.rj = function () {
        var e_11, _a, e_12, _b;
        _super.prototype.rj.call(this);
        this.aam(this.xAxis);
        this.aam(this.volumeXAxis);
        if (this.afr != null) {
            try {
                for (var _c = __values(fromEnum(this.afr)), _d = _c.next(); !_d.done; _d = _c.next()) {
                    var a = _d.value;
                    this.aam(a);
                }
            }
            catch (e_11_1) {
                e_11 = { error: e_11_1 };
            }
            finally {
                try {
                    if (_d && !_d.done && (_a = _c.return))
                        _a.call(_c);
                }
                finally {
                    if (e_11)
                        throw e_11.error;
                }
            }
        }
        this.aao(this.yAxis);
        this.aao(this.volumeAxis);
        if (this.afp != null) {
            try {
                for (var _e = __values(fromEnum(this.afp)), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var b = _f.value;
                    this.aao(b);
                }
            }
            catch (e_12_1) {
                e_12 = { error: e_12_1 };
            }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e.return))
                        _b.call(_e);
                }
                finally {
                    if (e_12)
                        throw e_12.error;
                }
            }
        }
        this.aam(this.zoomSliderXAxis);
        this.aao(this.zoomSliderAxis);
    };
    FinancialChart.prototype.get_fw = function () {
        return !this.afc;
    };
    Object.defineProperty(FinancialChart.prototype, "afk", {
        get: function () {
            return (this.externalObject._dynamicContent);
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.aln = function (a, b) {
        this.ak9(a, b);
        this.aj4();
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.axes.add(this.zoomSliderAxis);
            this.zoomSliderChart.axes.add(this.zoomSliderXAxis);
        }
        this.ak2();
        this.zoomSliderXAxis.itemsSource = this.xAxis.itemsSource;
        this.ak7();
        this.alo(a, b);
    };
    FinancialChart.prototype.ak2 = function () {
        if (this.dataChart == null || this.zoomSliderChart == null) {
            return;
        }
        this.zoomSliderChart.series.clear();
        var a = new List$1(Series.$, 0);
        for (var b = 0; b < this.dataChart.series.count; b++) {
            var c = this.dataChart.series._inner[b];
            if (this.ae8(c) || c.dc) {
                continue;
            }
            var d = void 0;
            var e = this.adp;
            e = this.ado(e);
            var f = this.ag9(c, b);
            if (e == 1) {
                switch (this.adf(this.ba != null && this.ba.dataSeries != null && this.ba.dataSeries.count > f ? this.ba.dataSeries._inner[f] : null)) {
                    case 1:
                        e = 2;
                        break;
                    case 2:
                        e = 3;
                        break;
                    case 3:
                        e = 4;
                        break;
                    case 4:
                        e = 5;
                        break;
                }
            }
            switch (e) {
                case 2:
                    d = this.aek();
                    this.adx.setDisplayType(d, 1);
                    break;
                case 3:
                    d = this.aek();
                    this.adx.setDisplayType(d, 0);
                    break;
                case 5:
                    d = this.aej();
                    break;
                case 6:
                    d = this.aeh();
                    break;
                default:
                case 4:
                    d = this.aei();
                    break;
            }
            var g = this.ba != null && this.ba.dataSeries != null && this.ba.dataSeries.count > f ? this.ba.dataSeries._inner[f] : null;
            if (d.dh && !d.dq) {
                this.adz.setCategoryMode(d, 1);
                this.adz.setXAxis(d, this.zoomSliderXAxis);
                this.adz.setYAxis(d, this.zoomSliderAxis);
                this.adz.setValueMemberPath(d, g == null ? null : this.ah3(g));
            }
            else if (d.dq) {
                this.adx.setCategoryMode(d, 1);
                this.adx.setXAxis(d, this.zoomSliderXAxis);
                this.adx.setYAxis(d, this.zoomSliderAxis);
                if (g != null) {
                    this.adx.setOpenMemberPath(d, g.getMemberPathFor(11));
                    this.adx.setHighMemberPath(d, g.getMemberPathFor(12));
                    this.adx.setLowMemberPath(d, g.getMemberPathFor(13));
                    this.adx.setCloseMemberPath(d, g.getMemberPathFor(14));
                    this.adx.setVolumeMemberPath(d, g.getMemberPathFor(15));
                }
            }
            d.name = "zoomSliderSeries_" + f;
            d.itemsSource = c.itemsSource;
            d.title = c.title;
            d.g1 = this.im;
            a.add(d);
        }
        for (var h = 0; h < a.count; h++) {
            var i = a._inner[h];
            this.zoomSliderChart.series.add(i);
            this.rr(i, h);
        }
    };
    FinancialChart.prototype.r6 = function (a, b, c) {
        var e_13, _a;
        _super.prototype.r6.call(this, a, b, c);
        if (a == null || !b) {
            return;
        }
        var d = true;
        var e = true;
        switch (c) {
            case "Brushes":
            case "Outlines":
                d = e = false;
                break;
        }
        if (this.indicatorCharts != null && d) {
            try {
                for (var _b = __values(fromEnum(this.indicatorCharts)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var f = _c.value;
                    a(f);
                }
            }
            catch (e_13_1) {
                e_13 = { error: e_13_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_13)
                        throw e_13.error;
                }
            }
        }
        if (this.volumeChart != null && e) {
            a(this.volumeChart);
        }
        if (this.zoomSliderChart != null) {
            a(this.zoomSliderChart);
        }
    };
    FinancialChart.prototype.ake = function (a, b) {
        var c = b;
        var d = a;
        var e = -1;
        if (this.indicatorCharts != null) {
            e = this.indicatorCharts.indexOf(d.cb);
        }
        e -= this.adr == null ? 0 : this.adr.count;
        if (this.applyCustomIndicators != null) {
            this.applyCustomIndicators(this, new FinancialChartCustomIndicatorArgs(c, d, e));
        }
    };
    FinancialChart.prototype.alb = function (a, b, c) {
        if (a != null) {
            if (b != null) {
                a.axes.remove(b);
            }
            a.axes.add(c);
        }
        if (this.e8) {
            this.aam(c);
        }
    };
    Object.defineProperty(FinancialChart.prototype, "afj", {
        get: function () {
            return TypeRegistrar.isRegistered("IgxZoomSliderComponent");
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.akf = function (a, b) {
        this.alf();
    };
    FinancialChart.prototype.afa = function (a, b) {
        if (b <= (0)) {
            return false;
        }
        switch (a) {
            case 5: return true;
            case 4:
            case 3: return b >= timeSpanFromDays(365);
            case 2: return b >= timeSpanFromDays(180);
            case 1: return b >= timeSpanFromDays(90);
            case 0: return b >= timeSpanFromDays(30);
        }
        return false;
    };
    FinancialChart.prototype.ak5 = function () {
        var e_14, _a;
        var a = this.ac9 != null ? this.ac9 : new FinancialChartRangeSelectorOptionCollection(1, [5, 4, 3, 2, 1, 0]);
        var b = new FinancialChartRangeSelectorOptionCollection(0);
        var c = this.xAxis;
        var d = +(c.actualMaximumValue) - +(c.actualMinimumValue);
        try {
            for (var _b = __values(fromEnum(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var e = _c.value;
                if (this.afa(e, d)) {
                    b.add(e);
                }
            }
        }
        catch (e_14_1) {
            e_14 = { error: e_14_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_14)
                    throw e_14.error;
            }
        }
        this.ac8 = b;
        if (this.adb != null) {
            this.adb.u = this.ac8;
        }
    };
    FinancialChart.prototype.akj = function (a, b) {
        this.ak5();
    };
    FinancialChart.prototype.ako = function (a, b) {
        this.adt = this.adb.ag;
    };
    FinancialChart.prototype.akn = function (a, b) {
        this.adr = this.adb.ae;
    };
    FinancialChart.prototype.akh = function (a, b) {
        this.alf();
    };
    FinancialChart.prototype.aki = function (a, b) {
        this.alh();
    };
    FinancialChart.prototype.aks = function (a, b) {
        var c = a;
        if (c.bf == null) {
            return;
        }
        if (this.afc) {
            this.ak4(c.bf);
        }
    };
    FinancialChart.prototype.akv = function (a) {
        SyncManager.e(a);
        a.axes.clear();
        a.series.clear();
        a.gridAreaRectChanged = delegateRemove(a.gridAreaRectChanged, runOn(this, this.akg));
        a.provideContainer(null);
        if (this.volumeChart == null && this.indicatorCharts == null) {
            this.yAxis.er = this.volumeAxis.er = this.indicatorAxis.er = 0;
            this.xAxis.ay.visibility = this.aca;
        }
    };
    FinancialChart.prototype.akt = function (a) {
        var b = a != this.zoomSliderChart;
        if (b) {
            if (this.dataChart != null) {
                a.tp = new Rect(0, this.dataChart.s9.x, a.tp.y, this.dataChart.s9.width, a.tp.height);
            }
            var c = ((function () {
                var $ret = new SyncSettings();
                $ret.syncChannel = "one";
                $ret.synchronizeHorizontally = true;
                $ret.synchronizeVertically = false;
                return $ret;
            })());
            SyncManager.d(a, c);
            SyncManager.c(a);
        }
        a.gridAreaRectChanged = delegateCombine(a.gridAreaRectChanged, runOn(this, this.akg));
        this.rl(a);
    };
    FinancialChart.prototype.aj4 = function () {
        if (this.indicatorCharts != null || this.volumeChart != null) {
            this.aak(this.xAxis, function (a) { return a.visibility = 1; });
        }
        var _loop_1 = function (a) {
            var b = this_1.afr._inner[a];
            var c = a < this_1.afr.count - 1 || this_1.volumeChart != null;
            this_1.aak(b, function (d) { return d.visibility = c ? 1 : 0; });
        };
        var this_1 = this;
        for (var a = 0; a < this.afr.count; a++) {
            _loop_1(a);
        }
    };
    FinancialChart.prototype.ak9 = function (a, b) {
        if (a != null) {
            this.akv(a);
        }
        if (b != null) {
            this.akt(b);
        }
    };
    FinancialChart.prototype.all = function (a, b) {
        this.ak9(a, b);
        this.aj4();
        if (this.volumeChart != null) {
            if (this.volumeAxis != null) {
                this.volumeChart.axes.add(this.volumeAxis);
                this.volumeChart.axes.add(this.volumeXAxis);
            }
            this.ak1();
            this.volumeXAxis.itemsSource = this.xAxis.itemsSource;
        }
        this.alm(a, b);
    };
    FinancialChart.prototype.akk = function (a, b) {
        this.alj();
    };
    FinancialChart.prototype.alj = function () {
        if (this.adb == null || +(this.adb.au) == +(dateMaxValue()) || +(this.adb.at) == +(dateMinValue()) || this.dataChart == null) {
            return;
        }
        var a = this.xAxis;
        var b = a.getWindowRectForSelection(this.adb.au, this.adb.at);
        if (b.width == 0 || isNaN_(b.width) || isInfinity(b.width)) {
            return;
        }
        this.afd = true;
        this.dataChart.tp = new Rect(0, b.left, this.dataChart.tp.top, b.width, this.dataChart.tp.height);
        if (this.aet != null) {
            this.aet.windowRect = this.dataChart.s9;
        }
        if (this.afc) {
            this.ak4(this.dataChart);
        }
        this.afd = false;
    };
    FinancialChart.prototype.akr = function (a, b) {
        this.ak5();
        this.ali(!this.afd);
    };
    FinancialChart.prototype.akd = function (a, b) {
        var _this = this;
        if (!this.afd) {
            if (this.afc) {
                this.ak4(a);
            }
            var c = false;
            var d = this.sh(function () { return _this.ali(true); }, c);
            c = d.p1;
            if (this.aet != null) {
                this.aet.windowRect = this.dataChart.s9;
            }
        }
    };
    FinancialChart.prototype.ald = function (a, b, c, d) {
        var e_15, _a;
        if (a == null || b == null) {
            return;
        }
        if (c != -1) {
            this.afd = true;
            a.tp = new Rect(0, d, a.s9.top, c, a.s9.height);
            this.afd = false;
        }
        var e = 1.7976931348623157E+308;
        var f = -1.7976931348623157E+308;
        var g = new Rect(0, 0, 0, 1, 1);
        var h = new ScalerParams(0, g, g, this.yAxis.cg, a.td);
        try {
            for (var _b = __values(fromEnum(a.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var i = _c.value;
                h.b = i.ge();
                var j = i.aq(a.s9);
                var k = j == null || j.c == 1.7976931348623157E+308 || isNaN_(j.c);
                if (k) {
                    continue;
                }
                var l = b.ei(j.c, h);
                var m = b.ei(j.b, h);
                f = Math.max(f, l);
                e = Math.min(e, m);
            }
        }
        catch (e_15_1) {
            e_15 = { error: e_15_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_15)
                    throw e_15.error;
            }
        }
        var n = a.s9.width;
        if (c != -1) {
            n = c;
        }
        var o = a.s9.left;
        if (d != -1) {
            o = d;
        }
        if (e == 1.7976931348623157E+308 || f == -1.7976931348623157E+308 || isNaN_(e) || isNaN_(f)) {
            return;
        }
        this.afd = true;
        var p = new Rect(0, o, e, n, f - e);
        a.tp = p;
        this.afd = false;
    };
    FinancialChart.prototype.alc = function (a) {
        if (a == null) {
            return;
        }
        if (a == this.dataChart) {
            this.ald(this.dataChart, this.yAxis, -1, -1);
            if (this.volumeChart != null) {
                this.ald(this.volumeChart, this.volumeAxis, this.dataChart.s9.width, this.dataChart.s9.left);
            }
        }
        else if (a == this.volumeChart) {
            this.ald(this.volumeChart, this.volumeAxis, -1, -1);
            this.ald(this.dataChart, this.yAxis, this.volumeChart.s9.width, this.volumeChart.s9.left);
        }
    };
    FinancialChart.prototype.ak4 = function (a) {
        var _this = this;
        this.sg(function () { return _this.alc(a); });
    };
    FinancialChart.prototype.akl = function (a, b) {
        if (this.afc) {
            this.ak4(a);
        }
    };
    FinancialChart.prototype.alk = function () {
        if (!this.afk) {
            return;
        }
        this.aj7();
        if (this.adp == 0) {
            this.zoomSliderChart = null;
        }
        else if (this.zoomSliderChart == null) {
            this.zoomSliderChart = ((function () {
                var $ret = new XamDataChart();
                $ret.name = "ZoomSliderChart";
                return $ret;
            })());
        }
        else {
            this.ak2();
        }
    };
    FinancialChart.prototype.aj7 = function () {
        var container_ = this.ag1.rootWrapper.getNativeElement();
        var containerParent_ = container_.parentElement;
        if (this.aet != null && containerParent_ != null && !this.afl) {
            this.afl = true;
            if (TypeRegistrar.isRegistered("IgxZoomSliderComponent")) {
                var z_ = this.aet;
                var f_ = this.externalObject;
                var sliderComponent_ = TypeRegistrar.get("IgxZoomSliderComponent");
                var sliderInstance_ = TypeRegistrar.create("IgxZoomSliderComponent");
                sliderInstance_._implementation = z_;
                sliderComponent_._staticStyling(container_, sliderInstance_, f_);
            }
        }
    };
    FinancialChart.prototype.ale = function () {
        var _this = this;
        if (this.adk != 1) {
            return;
        }
        this.aaq(function (a) {
            var e_16, _a;
            var b;
            b = a.breaks;
            b.clear();
            if (_this.xAxisBreaks == null) {
                return;
            }
            try {
                for (var _b = __values(fromEnum(_this.xAxisBreaks)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    b.add(c);
                }
            }
            catch (e_16_1) {
                e_16 = { error: e_16_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_16)
                        throw e_16.error;
                }
            }
        });
    };
    FinancialChart.prototype.s1 = function (a, b, c) {
        _super.prototype.s1.call(this, a, b, c);
        if (this.ba.dataSeries.count > 0) {
            if (this.adk == 1 && stringIsNullOrEmpty(this.k6)) {
                this.b0.setXMemberPath(a, c.getMemberPathFor(17));
            }
            if (stringIsNullOrEmpty(this.k8)) {
                this.b0.setYMemberPath(a, this.ah3(c));
            }
            if (stringIsNullOrEmpty(this.k2)) {
                this.b0.setLabelMemberPath(a, this.ah3(c));
            }
            if (stringIsNullOrEmpty(this.kz)) {
                this.b0.setContentMemberPath(a, this.ah3(c));
            }
        }
    };
    FinancialChart.prototype.ah2 = function (a) {
        switch (a) {
            case 0: return "Absolute Volume Oscillator";
            case 1: return "Accumulation/Distribution Indicator";
            case 2: return "Average Directional Index";
            case 3: return "Average True Range Indicator";
            case 4: return "Bollinger Bandwidth";
            case 5: return "Chaikin Oscillator";
            case 6: return "Chaikin Volatility Indicator";
            case 7: return "Commodity Channel Index";
            case 8: return "Detrended Price Oscillator";
            case 9: return "Ease of Movement Indicator";
            case 10: return "Fast Stochastic Oscillator";
            case 11: return "Force Index Indicator";
            case 12: return "Full Stochastic Oscillator";
            case 13: return "Market Facilitation Index";
            case 14: return "Mass Index Indicator";
            case 15: return "Median Price Indicator";
            case 16: return "Money Flow Index";
            case 17: return "MACD Indicator";
            case 18: return "Negative Volume Index";
            case 19: return "On Balance Volume Indicator";
            case 20: return "Percentage Price Oscillator";
            case 21: return "Percentage Volume Oscillator";
            case 22: return "Positive Volume Index";
            case 23: return "Price Volume Trend";
            case 24: return "ROC - Rate of Change Indicator";
            case 25: return "RSI - Relative Strength Index";
            case 26: return "Slow Stochastic Oscillator";
            case 27: return "Standard Deviation Indicator";
            case 28: return "Stoch RSI";
            case 29: return "TRIX Indicator";
            case 30: return "Typical Price Indicator";
            case 31: return "Ultimate Oscillator";
            case 32: return "Weighted Close Indicator";
            case 33: return "Williams %R Indicator";
            default: return "Unknown";
        }
    };
    FinancialChart.prototype.aam = function (a) {
        var e_17, _a;
        var _this = this;
        _super.prototype.aam.call(this, a);
        var b = a;
        this.aku(b);
        if (a.bf != null) {
            try {
                for (var _b = __values(fromEnum(a.bf.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var c = _c.value;
                    if (this.ae5(c)) {
                        this.adz.setXAxis(c, b);
                    }
                    else if (this.ae9(c)) {
                        this.adx.setXAxis(c, b);
                    }
                    else if (this.ae6(c)) {
                        this.ad1.setXAxis(c, b);
                    }
                    else if (this.ae8(c)) {
                        this.ad6.setXAxis(c, b);
                    }
                }
            }
            catch (e_17_1) {
                e_17 = { error: e_17_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_17)
                        throw e_17.error;
                }
            }
        }
        this.aky(function (d) {
            d.zoomMaximumCategoryRange = _this.agl;
            d.zoomMaximumItemSpan = _this.agm;
            d.zoomToCategoryRange = _this.agn;
            d.zoomToCategoryStart = _this.ago;
            d.zoomToItemSpan = _this.agp;
        });
        var d = a == this.zoomSliderXAxis;
        if (d) {
            a.jv = this.alq;
            a.eq = this.agw;
            this.aak(a, function (e) { return e.visibility = 1; });
        }
        var e = a;
        e.minimumValue = this.afx;
        e.maximumValue = this.afw;
        a.b0 = this.aff;
    };
    FinancialChart.prototype.aao = function (a) {
        var e_18, _a;
        _super.prototype.aao.call(this, a);
        if (a.bf != null && a == this.yAxis) {
            try {
                for (var _b = __values(fromEnum(a.bf.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var b = _c.value;
                    if (this.ae5(b)) {
                        this.adz.setYAxis(b, this.yAxis);
                    }
                    else if (this.ae9(b)) {
                        this.adx.setYAxis(b, this.yAxis);
                    }
                    else if (this.ae6(b)) {
                        this.ad1.setYAxis(b, this.yAxis);
                    }
                    else if (this.ae8(b)) {
                        this.ad6.setYAxis(b, this.yAxis);
                    }
                }
            }
            catch (e_18_1) {
                e_18 = { error: e_18_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_18)
                        throw e_18.error;
                }
            }
        }
        a.k8 = this.afg;
        a.l3 = this.agu;
        a.l2 = this.agt;
        if (a == this.yAxis) {
            a.lz = this.ags;
        }
        var c = a == this.zoomSliderAxis;
        if (c) {
            this.aak(a, function (d) { return d.visibility = 1; });
        }
        a.b0 = this.afh;
    };
    FinancialChart.prototype.aku = function (a) {
        a.itemsSource = this.dataChart != null && this.dataChart.series.count > 0 ? this.dataChart.series._inner[0].itemsSource : null;
        a.fz = XYChart.x9(a, this.ba.dataSeries);
        if (this.ba.dataSeries.count > 0) {
            var b = this.ba.dataSeries._inner[0].getMemberPathFor(17);
            a.hx(b);
        }
    };
    FinancialChart.prototype.rr = function (a, b) {
        _super.prototype.rr.call(this, a, b);
        if (a == null) {
            return;
        }
        var c = this.zoomSliderChart == a.cb;
        var d = this.dataChart != null && this.dataChart.series.contains(a);
        if ((d || c) && a.d4) {
            a.mq(this.acm != null ? ArrayExtension.getModulus$1(Brush.$, this.acm, b) : null, this.acn != null ? ArrayExtension.getModulus$1(Brush.$, this.acn, b) : null);
        }
        var e = this.ae6(a);
        if (this.ae8(a)) {
            a.o7 = this.aco != null ? ArrayExtension.getModulus$1(Brush.$, this.aco, b) : null;
            a.pc = this.acp != null ? ArrayExtension.getModulus$1(Brush.$, this.acp, b) : null;
            a.g1 = this.agi;
        }
        else if (e) {
            a.o7 = this.ack != null ? ArrayExtension.getModulus$1(Brush.$, this.ack, b) : null;
            a.g1 = this.agg;
        }
        else if (!a.dc && (d || c)) {
            a.o7 = this.aa != null ? ArrayExtension.getModulus$1(Brush.$, this.aa, b) : null;
            a.pc = this.ae != null ? ArrayExtension.getModulus$1(Brush.$, this.ae, b) : null;
        }
        var f = this.volumeChart != null && this.volumeChart == a.cb;
        if (f) {
            a.g1 = this.agk;
        }
        a.legend = c || f || e || !a.isUsableInLegend ? null : this.legend != null ? this.legend : this.ae7 ? this.adv : null;
    };
    FinancialChart.prototype.sc = function (a, b, c) {
        var e_19, _a, e_20, _b;
        var _this = this;
        _super.prototype.sc.call(this, a, b, c);
        switch (a) {
            case "YAxisIsLogarithmic":
                this.yAxis.lg = this.afi;
                if (this.volumeAxis != null) {
                    this.volumeAxis.lg = this.afi;
                }
                if (this.zoomSliderAxis != null) {
                    this.zoomSliderAxis.lg = this.afi;
                }
                break;
            case "YAxisLogarithmBase":
                this.yAxis.l7 = this.ahg;
                if (this.volumeAxis != null) {
                    this.volumeAxis.l7 = this.ahg;
                }
                if (this.zoomSliderAxis != null) {
                    this.zoomSliderAxis.l7 = this.ahg;
                }
                break;
            case "VolumeType":
                var d = EnumUtil.getEnumValue(FinancialChartVolumeType_$type, b);
                if (this.adi == 0) {
                    this.volumeChart = null;
                }
                else if (this.volumeChart == null) {
                    this.volumeChart = ((function () {
                        var $ret = new XamDataChart();
                        $ret.name = "VolumeChart";
                        return $ret;
                    })());
                }
                else {
                    this.ak1();
                }
                break;
            case "VolumeChart":
                this.all(typeCast(XamDataChart.$, b), typeCast(XamDataChart.$, c));
                break;
            case "DataChart":
                if (typeCast(XamDataChart.$, b) !== null) {
                    var e = b;
                    e.gridAreaRectChanged = delegateRemove(e.gridAreaRectChanged, runOn(this, this.akg));
                    e.actualWindowRectChanged = delegateRemove(e.actualWindowRectChanged, runOn(this, this.akd));
                    e.seriesDataUpdated = delegateRemove(e.seriesDataUpdated, runOn(this, this.akl));
                }
                if (this.dataChart != null) {
                    var f = this.dataChart;
                    f.gridAreaRectChanged = delegateCombine(f.gridAreaRectChanged, runOn(this, this.akg));
                    var g = this.dataChart;
                    g.actualWindowRectChanged = delegateCombine(g.actualWindowRectChanged, runOn(this, this.akd));
                    var h = this.dataChart;
                    h.seriesDataUpdated = delegateCombine(h.seriesDataUpdated, runOn(this, this.akl));
                }
                this.alk();
                break;
            case "XAxisMode":
                this.xAxis = this.acx(this.adk);
                this.xAxis.name = "xAxis";
                this.volumeXAxis = this.acx(this.adk);
                this.volumeXAxis.name = "volumeXAxis";
                this.indicatorXAxis = this.acx(this.adk);
                this.indicatorXAxis.name = "indicatorXAxis_0";
                this.zoomSliderXAxis = this.acx(this.adk);
                this.zoomSliderXAxis.name = "zoomSliderXAxis";
                this.aak(this.zoomSliderXAxis, function (i) { return i.visibility = 1; });
                this.aj4();
                if (this.adk == 1) {
                    this.ale();
                }
                break;
            case "YAxisMode":
                this.yAxis = this.aeb(this.adm);
                this.yAxis.name = "yAxis";
                this.zoomSliderAxis = this.aeb(this.adm);
                this.zoomSliderAxis.name = "zoomSliderAxis";
                this.volumeAxis = this.aeb(this.adm);
                this.volumeAxis.name = "volumeAxis";
                break;
            case "Toolbar":
                var i = typeCast(FinancialChartToolbar.$, b);
                if (i != null) {
                    i.rangeChanged = delegateRemove(i.rangeChanged, runOn(this, this.akk));
                    i.indicatorTypesChanged = delegateRemove(i.indicatorTypesChanged, runOn(this, this.akn));
                    i.overlayTypesChanged = delegateRemove(i.overlayTypesChanged, runOn(this, this.ako));
                }
                if (this.adb != null) {
                    this.adb.ae = this.adr;
                    this.adb.ag = this.adt;
                    this.adb.u = this.ac8;
                    this.ali(true);
                    var j = this.adb;
                    j.rangeChanged = delegateCombine(j.rangeChanged, runOn(this, this.akk));
                    var k = this.adb;
                    k.indicatorTypesChanged = delegateCombine(k.indicatorTypesChanged, runOn(this, this.akn));
                    var l = this.adb;
                    l.overlayTypesChanged = delegateCombine(l.overlayTypesChanged, runOn(this, this.ako));
                }
                break;
            case "XAxis":
                var m = typeCast(CategoryAxisBase.$, b);
                if (m != null) {
                    if (this.dataChart != null) {
                        this.dataChart.axes.remove(m);
                    }
                }
                var n = typeCast(ITimeRangeSelectorAxis_$type, b);
                if (n != null) {
                    n.visibleRangeChanged = delegateRemove(n.visibleRangeChanged, runOn(this, this.akr));
                }
                if (this.dataChart != null) {
                    this.dataChart.axes.add(this.xAxis);
                }
                if (this.e8) {
                    this.aam(this.xAxis);
                    this.q9();
                }
                this.ali(false);
                this.alj();
                this.ak5();
                var o = this.xAxis;
                o.visibleRangeChanged = delegateCombine(o.visibleRangeChanged, runOn(this, this.akr));
                break;
            case "XAxisZoomMaximumCategoryRange":
                this.aky(function (p) { return p.zoomMaximumCategoryRange = _this.agl; });
                break;
            case "XAxisZoomMaximumItemSpan":
                this.aky(function (p) { return p.zoomMaximumItemSpan = _this.agm; });
                break;
            case "XAxisZoomToCategoryRange":
                this.aky(function (p) { return p.zoomToCategoryRange = _this.agn; });
                break;
            case "XAxisZoomToCategoryStart":
                this.aky(function (p) { return p.zoomToCategoryStart = _this.ago; });
                break;
            case "XAxisZoomToItemSpan":
                this.aky(function (p) { return p.zoomToItemSpan = _this.agp; });
                break;
            case "ChartType":
                this.sw();
                break;
            case "VolumeXAxis":
                this.alb(this.volumeChart, typeCast(Axis.$, b), this.volumeXAxis);
                break;
            case "ZoomSliderXAxis":
                this.alb(this.zoomSliderChart, typeCast(Axis.$, b), this.zoomSliderXAxis);
                break;
            case "IndicatorXAxis":
                this.alf();
                break;
            case "YAxis":
                var p = typeCast(NumericYAxis.$, b);
                if (p != null) {
                    if (this.dataChart != null) {
                        this.dataChart.axes.remove(p);
                    }
                }
                if (this.dataChart != null) {
                    this.dataChart.axes.add(this.yAxis);
                }
                if (this.e8) {
                    this.aao(this.yAxis);
                    this.aao(this.yAxis);
                }
                var q = this.yAxis;
                q.rangeChanged = delegateCombine(q.rangeChanged, runOn(this, this.aks));
                break;
            case "VolumeAxis":
                var r = typeCast(Axis.$, b);
                if (this.volumeChart != null && r != null) {
                    this.volumeChart.axes.remove(r);
                }
                if (this.volumeChart != null && this.volumeAxis != null) {
                    this.volumeChart.axes.add(this.volumeAxis);
                    this.ak1();
                }
                if (this.e8) {
                    this.aao(this.volumeAxis);
                }
                var s = this.volumeAxis;
                s.rangeChanged = delegateCombine(s.rangeChanged, runOn(this, this.aks));
                break;
            case "IndicatorAxis":
                if (this.indicatorCharts != null) {
                    for (var t = 0; t < this.indicatorCharts.count; t++) {
                        var u = this.indicatorCharts._inner[t];
                        var v = new List$1(Axis.$, 0);
                        try {
                            for (var _c = (e_19 = void 0, __values(fromEnum(u.axes))), _d = _c.next(); !_d.done; _d = _c.next()) {
                                var w = _d.value;
                                if (typeCast(NumericYAxis.$, w) !== null) {
                                    v.add(w);
                                }
                            }
                        }
                        catch (e_19_1) {
                            e_19 = { error: e_19_1 };
                        }
                        finally {
                            try {
                                if (_d && !_d.done && (_a = _c.return))
                                    _a.call(_c);
                            }
                            finally {
                                if (e_19)
                                    throw e_19.error;
                            }
                        }
                        try {
                            for (var _e = (e_20 = void 0, __values(fromEnum(v))), _f = _e.next(); !_f.done; _f = _e.next()) {
                                var x = _f.value;
                                u.axes.remove(x);
                            }
                        }
                        catch (e_20_1) {
                            e_20 = { error: e_20_1 };
                        }
                        finally {
                            try {
                                if (_f && !_f.done && (_b = _e.return))
                                    _b.call(_e);
                            }
                            finally {
                                if (e_20)
                                    throw e_20.error;
                            }
                        }
                        var y = null;
                        if (t == 0) {
                            y = this.indicatorAxis;
                        }
                        else if (this.adm == 1) {
                            y = this.aeb(this.adm);
                        }
                        else if (typeCast(NumericYAxis.$, this.indicatorAxis) !== null) {
                            y = new NumericYAxis();
                        }
                        if (y != null) {
                            u.axes.add(y);
                        }
                        if (this.e8) {
                            this.aao(y);
                        }
                    }
                }
                break;
            case "IsWindowSyncedToVisibleRange":
                if (this.dataChart != null) {
                    this.dataChart.un = this.fx && this.fw;
                }
                if (this.volumeChart != null) {
                    this.volumeChart.un = this.fx && this.fw;
                }
                if (this.afc) {
                    this.alc(this.dataChart);
                }
                else {
                    this.volumeChart.vu = 1;
                }
                break;
            case "IndicatorTypes":
                var z = typeCast(ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), b);
                if (z != null) {
                    z.collectionChanged = delegateRemove(z.collectionChanged, runOn(this, this.akh));
                }
                var aa = typeCast(ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), c);
                if (aa != null) {
                    aa.collectionChanged = delegateCombine(aa.collectionChanged, runOn(this, this.akh));
                }
                this.alf();
                break;
            case "OverlayTypes":
                var ab = typeCast(ObservableCollection$1.$.specialize(FinancialOverlayType_$type), b);
                if (ab != null) {
                    ab.collectionChanged = delegateRemove(ab.collectionChanged, runOn(this, this.aki));
                }
                var ac = typeCast(ObservableCollection$1.$.specialize(FinancialOverlayType_$type), c);
                if (ac != null) {
                    ac.collectionChanged = delegateCombine(ac.collectionChanged, runOn(this, this.aki));
                }
                this.alh();
                break;
            case "YAxisAbbreviateLargeNumbers":
                this.aav(function (ad) { return ad.k8 = _this.afg; });
                break;
            case "YAxisMinimumValue":
                this.aaw(function (ad) { return ad.l3 = _this.agu; }, false);
                break;
            case "YAxisMaximumValue":
                this.aaw(function (ad) { return ad.l2 = _this.agt; }, false);
                break;
            case "YAxisInterval":
                this.aaw(function (ad) { return ad.lz = _this.ags; }, false);
                break;
            case "Thickness":
            case "ZoomSliderType":
                this.alk();
                break;
            case "ZoomSliderChart":
                if (!this.afj) {
                    return;
                }
                this.aln(typeCast(XamDataChart.$, b), typeCast(XamDataChart.$, c));
                break;
            case "NegativeBrushes":
            case "NegativeOutlines":
                this.aka(function (ad, ae) {
                    if (ad.d4) {
                        ad.mq(_this.acm != null ? ArrayExtension.getModulus$1(Brush.$, _this.acm, ae) : null, _this.acn != null ? ArrayExtension.getModulus$1(Brush.$, _this.acn, ae) : null);
                    }
                }, true);
                break;
            case "OverlayBrushes":
                this.aj9(function (ad, ae) { return ad.o7 = _this.aco != null ? ArrayExtension.getModulus$1(Brush.$, _this.aco, ae) : null; });
                break;
            case "OverlayOutlines":
                this.aj9(function (ad, ae) { return ad.pc = _this.acp != null ? ArrayExtension.getModulus$1(Brush.$, _this.acp, ae) : null; });
                break;
            case "OverlayThickness":
                this.aj9(function (ad, ae) { return ad.g1 = _this.agi; });
                break;
            case "OverlayMultiplier":
                this.aj9(function (ad, ae) { return _this.ad6.setMultiplier(ad, _this.agh); });
                break;
            case "VolumeBrushes":
                this.akb(function (ad, ae) { return ad.o7 = ArrayExtension.getModulus$1(Brush.$, _this.acq, ae); });
                break;
            case "VolumeOutlines":
                this.akb(function (ad, ae) { return ad.pc = ArrayExtension.getModulus$1(Brush.$, _this.acr, ae); });
                break;
            case "VolumeThickness":
                this.akb(function (ad, ae) { return ad.g1 = _this.agk; });
                break;
            case "IndicatorNegativeBrushes":
                this.aj8(function (ad, ae) { return _this.ad1.setNegativeBrush(ad, ArrayExtension.getModulus$1(Brush.$, _this.acl, ae)); });
                break;
            case "IndicatorBrushes":
                this.aj8(function (ad, ae) { return ad.o7 = ArrayExtension.getModulus$1(Brush.$, _this.ack, ae); });
                break;
            case "IndicatorThickness":
                this.aj8(function (ad, ae) { return ad.g1 = _this.agg; });
                break;
            case "IndicatorDisplayTypes":
                this.aj8(function (ad, ae) { return _this.ad1.setDisplayType(ad, ArrayExtension.getModulus$1(IndicatorDisplayType_$type, _this.ad3, ae)); });
                break;
            case "IndicatorPeriod":
                this.aj8(function (ad, ae) {
                    if (_this.ahb == -2147483648) {
                        return;
                    }
                    _this.ad1.setPeriodOverride(ad, _this.ahb);
                });
                break;
            case "IndicatorMultiplier":
                this.aj8(function (ad, ae) { return _this.ad1.setMultiplier(ad, _this.agf); });
                break;
            case "IndicatorSmoothingPeriod":
                this.aj8(function (ad, ae) { return _this.ad1.setSmoothingPeriod(ad, _this.ahe); });
                break;
            case "IndicatorShortPeriod":
                this.aj8(function (ad, ae) { return _this.ad1.setShortPeriod(ad, _this.ahc); });
                break;
            case "IndicatorLongPeriod":
                this.aj8(function (ad, ae) { return _this.ad1.setLongPeriod(ad, _this.aha); });
                break;
            case "IndicatorSignalPeriod":
                this.aj8(function (ad, ae) { return _this.ad1.setSignalPeriod(ad, _this.ahd); });
                break;
            case "RangeSelectorOptions":
                var ad = typeCast(FinancialChartRangeSelectorOptionCollection.$, b);
                if (ad != null) {
                    ad.collectionChanged = delegateRemove(ad.collectionChanged, runOn(this, this.akj));
                }
                if (this.ac9 != null) {
                    var ae = this.ac9;
                    ae.collectionChanged = delegateCombine(ae.collectionChanged, runOn(this, this.akj));
                }
                this.ak5();
                break;
            case "CustomIndicatorNames":
                var af = typeCast(ObservableCollection$1.$.specialize(String_$type), b);
                if (af != null) {
                    af.collectionChanged = delegateRemove(af.collectionChanged, runOn(this, this.akf));
                }
                if (this.customIndicatorNames != null) {
                    var ag = this.customIndicatorNames;
                    ag.collectionChanged = delegateCombine(ag.collectionChanged, runOn(this, this.akf));
                }
                this.alf();
                break;
            case "Legend":
                if (this.zoomSliderChart != null) {
                    this.zoomSliderChart.legend = null;
                }
                break;
            case "Brushes":
                this.aka(function (ah, ai) { return ah.o7 = _this.aa != null ? ArrayExtension.getModulus$1(Brush.$, _this.aa, ai) : null; }, true);
                break;
            case "Outlines":
                this.aka(function (ah, ai) { return ah.pc = _this.ae != null ? ArrayExtension.getModulus$1(Brush.$, _this.ae, ai) : null; }, true);
                break;
            case "XAxisLabelVisibility":
                if (this.aca == 0 && this.zoomSliderXAxis != null) {
                    this.aak(this.zoomSliderXAxis, function (ah) { return ah.visibility = 1; });
                }
                this.aj4();
                break;
            case "YAxisLabelVisibility":
                if (this.acb != 0 || this.zoomSliderAxis == null) {
                    break;
                }
                this.aak(this.zoomSliderAxis, function (ah) { return ah.visibility = 1; });
                break;
            case "ZoomSliderXAxisMajorStroke":
                this.zoomSliderXAxis.jv = this.alq;
                break;
            case "ZoomSliderXAxisMajorStrokeThickness":
                this.zoomSliderXAxis.eq = this.agw;
                break;
            case "FinancialChartLegend":
            case "IsLegendVisible":
                var ah_1 = this.ae7 && this.legend == null;
                {
                    var ai = function (aj, ak) {
                        if (aj.isUsableInLegend) {
                            aj.legend = ah_1 ? _this.adv : null;
                        }
                    };
                    this.aka(ai, false);
                    this.aj9(ai);
                }
                break;
            case "ZoomSliderAxis":
                var aj = typeCast(Axis.$, b);
                if (aj != null && this.zoomSliderChart != null) {
                    this.zoomSliderChart.axes.remove(aj);
                }
                if (this.zoomSliderAxis != null) {
                    if (this.zoomSliderChart != null) {
                        this.zoomSliderChart.axes.add(this.zoomSliderAxis);
                        this.ak2();
                        this.zoomSliderXAxis.itemsSource = this.xAxis.itemsSource;
                    }
                    if (this.e8) {
                        this.aao(this.zoomSliderAxis);
                    }
                    this.aak(this.zoomSliderAxis, function (ak) { return ak.visibility = 1; });
                }
                break;
            case "XAxisMinimumValue":
                this.aaq(function (ak) {
                    var al = typeCast(ITimeRangeSelectorAxis_$type, ak);
                    if (al != null) {
                        al.minimumValue = _this.afx;
                    }
                });
                break;
            case "XAxisMaximumValue":
                this.aaq(function (ak) {
                    var al = typeCast(ITimeRangeSelectorAxis_$type, ak);
                    if (al != null) {
                        al.maximumValue = _this.afw;
                    }
                });
                break;
            case FinancialChart.ajb:
                this.aar(function (ak) { return ak.b0 = _this.aff; }, a);
                break;
            case FinancialChart.ajm:
                this.aav(function (ak) { return ak.b0 = _this.afh; });
                break;
        }
    };
    FinancialChart.prototype.get_by = function () {
        return 1;
    };
    Object.defineProperty(FinancialChart.prototype, "by", {
        get: function () {
            return this.get_by();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "afi", {
        get: function () {
            return this.ae0;
        },
        set: function (a) {
            var b = this.afi;
            if (a != b) {
                this.ae0 = a;
                this.sc("YAxisIsLogarithmic", b, this.afi);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahg", {
        get: function () {
            return this.ag8;
        },
        set: function (a) {
            var b = this.ahg;
            if (a != b) {
                this.ag8 = a;
                this.sc("YAxisLogarithmBase", b, this.ahg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ags", {
        get: function () {
            return this.af9;
        },
        set: function (a) {
            var b = this.ags;
            if (a != b) {
                this.af9 = a;
                this.sc("YAxisInterval", b, this.ags);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "agu", {
        get: function () {
            return this.agb;
        },
        set: function (a) {
            var b = this.agu;
            if (a != b) {
                this.agb = a;
                this.sc("YAxisMinimumValue", b, this.agu);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "agt", {
        get: function () {
            return this.aga;
        },
        set: function (a) {
            var b = this.agt;
            if (a != b) {
                this.aga = a;
                this.sc("YAxisMaximumValue", b, this.agt);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "agv", {
        get: function () {
            return this.agc;
        },
        set: function (a) {
            var b = this.agv;
            if (a != b) {
                this.agc = a;
                this.sc("YAxisMinorInterval", b, this.agv);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "agr", {
        get: function () {
            return this.yAxis.lv;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "agq", {
        get: function () {
            return this.yAxis.lu;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "adi", {
        get: function () {
            return this.adg;
        },
        set: function (a) {
            var b = this.adi;
            if (a != b) {
                this.adg = a;
                this.sc("VolumeType", enumGetBox(FinancialChartVolumeType_$type, b), enumGetBox(FinancialChartVolumeType_$type, this.adi));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "adk", {
        get: function () {
            return this.adj;
        },
        set: function (a) {
            var b = this.adk;
            if (a != b) {
                this.adj = a;
                this.sc("XAxisMode", enumGetBox(FinancialChartXAxisMode_$type, b), enumGetBox(FinancialChartXAxisMode_$type, this.adk));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "agl", {
        get: function () {
            return this.af4;
        },
        set: function (a) {
            var b = this.agl;
            if (a != b) {
                this.af4 = a;
                this.sc("XAxisZoomMaximumCategoryRange", b, this.agl);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ago", {
        get: function () {
            return this.af7;
        },
        set: function (a) {
            var b = this.ago;
            if (a != b) {
                this.af7 = a;
                this.sc("XAxisZoomToCategoryStart", b, this.ago);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "agm", {
        get: function () {
            return this.af5;
        },
        set: function (a) {
            var b = this.agm;
            if (a != b) {
                this.af5 = a;
                this.sc("XAxisZoomMaximumItemSpan", b, this.agm);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "agn", {
        get: function () {
            return this.af6;
        },
        set: function (a) {
            var b = this.agn;
            if (a != b) {
                this.af6 = a;
                this.sc("XAxisZoomToCategoryRange", b, this.agn);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "agp", {
        get: function () {
            return this.af8;
        },
        set: function (a) {
            var b = this.agp;
            if (a != b) {
                this.af8 = a;
                this.sc("XAxisZoomToItemSpan", b, this.agp);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "adm", {
        get: function () {
            return this.adl;
        },
        set: function (a) {
            var b = this.adm;
            if (a != b) {
                this.adl = a;
                this.sc("YAxisMode", enumGetBox(FinancialChartYAxisMode_$type, b), enumGetBox(FinancialChartYAxisMode_$type, this.adm));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "afb", {
        get: function () {
            return this.aev;
        },
        set: function (a) {
            var b = this.afb;
            if (a != b) {
                this.aev = a;
                this.sc("IsToolbarVisible", b, this.afb);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "add", {
        get: function () {
            return this.adc;
        },
        set: function (a) {
            var b = this.add;
            if (a != b) {
                this.adc = a;
                this.sc("ChartType", enumGetBox(FinancialChartType_$type, b), enumGetBox(FinancialChartType_$type, this.add));
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.get_aa5 = function () {
        return _super.prototype.get_aa5.call(this);
    };
    FinancialChart.prototype.set_aa5 = function (a) {
        _super.prototype.set_aa5.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "afc", {
        get: function () {
            return this.aew;
        },
        set: function (a) {
            var b = this.afc;
            if (a != b) {
                this.aew = a;
                this.sc("IsWindowSyncedToVisibleRange", b, this.afc);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "adr", {
        get: function () {
            return this.adq;
        },
        set: function (a) {
            var b = this.adr;
            if (a != b) {
                this.adq = a;
                this.sc("IndicatorTypes", b, this.adr);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "adt", {
        get: function () {
            return this.ads;
        },
        set: function (a) {
            var b = this.adt;
            if (a != b) {
                this.ads = a;
                this.sc("OverlayTypes", b, this.adt);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "indicatorCharts", {
        get: function () {
            return this.afn;
        },
        set: function (a) {
            var b = this.indicatorCharts;
            if (a != b) {
                this.afn = a;
                this.sc("IndicatorCharts", b, this.indicatorCharts);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "afg", {
        get: function () {
            return this.aey;
        },
        set: function (a) {
            var b = this.afg;
            if (a != b) {
                this.aey = a;
                this.sc("YAxisAbbreviateLargeNumbers", b, this.afg);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.get_ig = function () {
        return _super.prototype.get_ig.call(this);
    };
    FinancialChart.prototype.set_ig = function (a) {
        _super.prototype.set_ig.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "aff", {
        get: function () {
            return this.aex;
        },
        set: function (a) {
            var b = this.aff;
            if (a != b) {
                this.aex = a;
                this.sc(FinancialChart.ajb, b, this.aff);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "afh", {
        get: function () {
            return this.aez;
        },
        set: function (a) {
            var b = this.afh;
            if (a != b) {
                this.aez = a;
                this.sc(FinancialChart.ajm, b, this.afh);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "zoomSliderChart", {
        get: function () {
            return this.aep;
        },
        set: function (a) {
            var b = this.zoomSliderChart;
            if (a != b) {
                this.aep = a;
                this.sc("ZoomSliderChart", b, this.zoomSliderChart);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "zoomSliderAxis", {
        get: function () {
            return this.aea;
        },
        set: function (a) {
            var b = this.zoomSliderAxis;
            if (a != b) {
                this.aea = a;
                this.sc("ZoomSliderAxis", b, this.zoomSliderAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "zoomSliderXAxis", {
        get: function () {
            return this.acv;
        },
        set: function (a) {
            var b = this.zoomSliderXAxis;
            if (a != b) {
                this.acv = a;
                this.sc("ZoomSliderXAxis", b, this.zoomSliderXAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "adp", {
        get: function () {
            return this.adn;
        },
        set: function (a) {
            var b = this.adp;
            if (a != b) {
                this.adn = a;
                this.sc("ZoomSliderType", enumGetBox(FinancialChartZoomSliderType_$type, b), enumGetBox(FinancialChartZoomSliderType_$type, this.adp));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "acm", {
        get: function () {
            return this.ace;
        },
        set: function (a) {
            var b = this.acm;
            if (a != b) {
                this.ace = a;
                this.sc("NegativeBrushes", b, this.acm);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "acn", {
        get: function () {
            return this.acf;
        },
        set: function (a) {
            var b = this.acn;
            if (a != b) {
                this.acf = a;
                this.sc("NegativeOutlines", b, this.acn);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aco", {
        get: function () {
            return this.acg;
        },
        set: function (a) {
            var b = this.aco;
            if (a != b) {
                this.acg = a;
                this.sc("OverlayBrushes", b, this.aco);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "acp", {
        get: function () {
            return this.ach;
        },
        set: function (a) {
            var b = this.acp;
            if (a != b) {
                this.ach = a;
                this.sc("OverlayOutlines", b, this.acp);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "acr", {
        get: function () {
            return this.acj;
        },
        set: function (a) {
            var b = this.acr;
            if (a != b) {
                this.acj = a;
                this.sc("VolumeOutlines", b, this.acr);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "acq", {
        get: function () {
            return this.aci;
        },
        set: function (a) {
            var b = this.acq;
            if (a != b) {
                this.aci = a;
                this.sc("VolumeBrushes", b, this.acq);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "acl", {
        get: function () {
            return this.acd;
        },
        set: function (a) {
            var b = this.acl;
            if (a != b) {
                this.acd = a;
                this.sc("IndicatorNegativeBrushes", b, this.acl);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ack", {
        get: function () {
            return this.acc;
        },
        set: function (a) {
            var b = this.ack;
            if (a != b) {
                this.acc = a;
                this.sc("IndicatorBrushes", b, this.ack);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "agk", {
        get: function () {
            return this.af3;
        },
        set: function (a) {
            var b = this.agk;
            if (a != b) {
                this.af3 = a;
                this.sc("VolumeThickness", b, this.agk);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "agi", {
        get: function () {
            return this.af1;
        },
        set: function (a) {
            var b = this.agi;
            if (a != b) {
                this.af1 = a;
                this.sc("OverlayThickness", b, this.agi);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "agh", {
        get: function () {
            return this.af0;
        },
        set: function (a) {
            var b = this.agh;
            if (a != b) {
                this.af0 = a;
                this.sc("OverlayMultiplier", b, this.agh);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "agg", {
        get: function () {
            return this.afz;
        },
        set: function (a) {
            var b = this.agg;
            if (a != b) {
                this.afz = a;
                this.sc("IndicatorThickness", b, this.agg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ad3", {
        get: function () {
            return this.ad2;
        },
        set: function (a) {
            var b = this.ad3;
            if (a != b) {
                this.ad2 = a;
                this.sc("IndicatorDisplayTypes", b, this.ad3);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahb", {
        get: function () {
            return this.ag4;
        },
        set: function (a) {
            var b = this.ahb;
            if (a != b) {
                this.ag4 = a;
                this.sc("IndicatorPeriod", b, this.ahb);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "agf", {
        get: function () {
            return this.afy;
        },
        set: function (a) {
            var b = this.agf;
            if (a != b) {
                this.afy = a;
                this.sc("IndicatorMultiplier", b, this.agf);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahe", {
        get: function () {
            return this.ag7;
        },
        set: function (a) {
            var b = this.ahe;
            if (a != b) {
                this.ag7 = a;
                this.sc("IndicatorSmoothingPeriod", b, this.ahe);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahc", {
        get: function () {
            return this.ag5;
        },
        set: function (a) {
            var b = this.ahc;
            if (a != b) {
                this.ag5 = a;
                this.sc("IndicatorShortPeriod", b, this.ahc);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "aha", {
        get: function () {
            return this.ag3;
        },
        set: function (a) {
            var b = this.aha;
            if (a != b) {
                this.ag3 = a;
                this.sc("IndicatorLongPeriod", b, this.aha);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ahd", {
        get: function () {
            return this.ag6;
        },
        set: function (a) {
            var b = this.ahd;
            if (a != b) {
                this.ag6 = a;
                this.sc("IndicatorSignalPeriod", b, this.ahd);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ac9", {
        get: function () {
            return this.ac7;
        },
        set: function (a) {
            var b = this.ac9;
            if (a != b) {
                this.ac7 = a;
                this.sc("RangeSelectorOptions", b, this.ac9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "customIndicatorNames", {
        get: function () {
            return this.ac3;
        },
        set: function (a) {
            var b = this.ac3;
            if (a != b) {
                this.ac3 = a;
                this.sc("CustomIndicatorNames", b, this.customIndicatorNames);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.prototype.get_fx = function () {
        return _super.prototype.get_fx.call(this);
    };
    FinancialChart.prototype.set_fx = function (a) {
        _super.prototype.set_fx.call(this, a);
    };
    Object.defineProperty(FinancialChart.prototype, "alq", {
        get: function () {
            return this.alp;
        },
        set: function (a) {
            var b = this.alq;
            if (a != b) {
                this.alp = a;
                this.sc("ZoomSliderXAxisMajorStroke", b, this.alq);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "agw", {
        get: function () {
            return this.agd;
        },
        set: function (a) {
            var b = this.agw;
            if (a != b) {
                this.agd = a;
                this.sc("ZoomSliderXAxisMajorStrokeThickness", b, this.agw);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "ae7", {
        get: function () {
            return this.aeu;
        },
        set: function (a) {
            var b = this.ae7;
            if (a != b) {
                this.aeu = a;
                this.sc("IsLegendVisible", b, this.ae7);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "adv", {
        get: function () {
            return this.adu;
        },
        set: function (a) {
            var b = this.adv;
            if (a != b) {
                this.adu = a;
                this.sc("FinancialChartLegend", b, this.adv);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "xAxis", {
        get: function () {
            return this.acu;
        },
        set: function (a) {
            var b = this.xAxis;
            if (a != b) {
                this.acu = a;
                this.sc("XAxis", b, this.xAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "yAxis", {
        get: function () {
            return this.ad9;
        },
        set: function (a) {
            var b = this.yAxis;
            if (a != b) {
                this.ad9 = a;
                this.sc("YAxis", b, this.yAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "volumeAxis", {
        get: function () {
            return this.ad8;
        },
        set: function (a) {
            var b = this.volumeAxis;
            if (a != b) {
                this.ad8 = a;
                this.sc("VolumeAxis", b, this.volumeAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "volumeXAxis", {
        get: function () {
            return this.act;
        },
        set: function (a) {
            var b = this.volumeXAxis;
            if (a != b) {
                this.act = a;
                this.sc("VolumeXAxis", b, this.volumeXAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "indicatorAxis", {
        get: function () {
            return this.ad7;
        },
        set: function (a) {
            var b = this.indicatorAxis;
            if (a != b) {
                this.ad7 = a;
                this.sc("IndicatorAxis", b, this.indicatorAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "indicatorXAxis", {
        get: function () {
            return this.acs;
        },
        set: function (a) {
            var b = this.indicatorXAxis;
            if (a != b) {
                this.acs = a;
                this.sc("IndicatorXAxis", b, this.indicatorXAxis);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "afp", {
        get: function () {
            return this.afm;
        },
        set: function (a) {
            var b = this.afp;
            if (a != b) {
                this.afm = a;
                this.sc("IndicatorAxes", b, this.afp);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "afr", {
        get: function () {
            return this.afo;
        },
        set: function (a) {
            var b = this.afr;
            if (a != b) {
                this.afo = a;
                this.sc("IndicatorXAxes", b, this.afr);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "afx", {
        get: function () {
            return this.afv;
        },
        set: function (a) {
            var b = this.afx;
            if (+a != +b) {
                this.afv = a;
                this.sc("XAxisMinimumValue", b, this.afx);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "afw", {
        get: function () {
            return this.afu;
        },
        set: function (a) {
            var b = this.afw;
            if (+a != +b) {
                this.afu = a;
                this.sc("XAxisMaximumValue", b, this.afw);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChart.prototype, "xAxisBreaks", {
        get: function () {
            return this.afs;
        },
        enumerable: false,
        configurable: true
    });
    FinancialChart.$t = markType(FinancialChart, 'FinancialChart', XYChart.$);
    FinancialChart.ahf = 0;
    FinancialChart.ajb = "XAxisEnhancedIntervalPreferMoreCategoryLabels";
    FinancialChart.ajm = "YAxisEnhancedIntervalPreferMoreCategoryLabels";
    return FinancialChart;
}(XYChart));
export { FinancialChart };
/**
 * @hidden
 */
var FinancialChartToolbar = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChartToolbar, _super);
    function FinancialChartToolbar(a, b) {
        var _this = _super.call(this, "financialChartToolbar", b, "") || this;
        _this.o = null;
        _this.r = null;
        _this.z = null;
        _this.p = null;
        _this.w = null;
        _this.aq = dateMaxValue();
        _this.ap = dateMinValue();
        _this.ao = dateMaxValue();
        _this.an = dateMinValue();
        _this.rangeChanged = null;
        _this.chartTypeChanged = null;
        _this.trendLineTypeChanged = null;
        _this.volumeTypeChanged = null;
        _this.indicatorTypesChanged = null;
        _this.overlayTypesChanged = null;
        _this.x = 0;
        _this.ah = 0;
        _this.ab = 0;
        _this.ad = null;
        _this.af = null;
        _this.t = null;
        _this.ak = false;
        _this.o = a;
        _this.w = new FinancialChartToolbarViewModel();
        _this.s = new FinancialChartRangeSelector(a != null ? a.ahr : null);
        _this.aa = new FinancialChartTypePicker(a != null ? a.aho : null);
        _this.q = new FinancialChartIndicatorMenu(1, a != null ? a.ahp : null);
        return _this;
    }
    FinancialChartToolbar.prototype.bg = function (a) {
        var b = a.querySelectorAll(".financialChartToolbarArea");
        if (b != null && b.length > 0) {
            this.g = b[0];
            if (!this.al) {
                this.g.hide();
            }
        }
        var c = a.querySelectorAll(".financialChartIndicatorMenu");
        if (c != null && c.length > 0) {
            this.q.g = c[0];
        }
        var d = a.querySelectorAll(".financialChartRangeSelector");
        if (d != null && d.length > 0) {
            this.s.g = d[0];
        }
        var e = a.querySelectorAll(".financialChartTypePicker");
        if (e != null && e.length > 0) {
            this.aa.g = e[0];
        }
    };
    FinancialChartToolbar.prototype.bl = function (a) {
        this.q.u(a);
        this.aa.u(a);
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "s", {
        get: function () {
            return this.r;
        },
        set: function (a) {
            var b = this.s;
            if (a != b) {
                this.r = a;
                this.bm("RangeSelector", b, this.s);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "aa", {
        get: function () {
            return this.z;
        },
        set: function (a) {
            var b = this.aa;
            if (a != b) {
                this.z = a;
                this.bm("ChartTypePicker", b, this.aa);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "q", {
        get: function () {
            return this.p;
        },
        set: function (a) {
            var b = this.q;
            if (a != b) {
                this.p = a;
                this.bm("IndicatorMenu", b, this.q);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChartToolbar.prototype.bm = function (a, b, c) {
        switch (a) {
            case "RangeStart":
                if (this.s != null) {
                    this.s.t = this.as;
                }
                break;
            case "RangeEnd":
                if (this.s != null) {
                    this.s.s = this.ar;
                }
                break;
            case "SelectionStart":
                if (this.s != null) {
                    this.s.v = this.au;
                }
                break;
            case "SelectionEnd":
                if (this.s != null) {
                    this.s.u = this.at;
                }
                break;
            case "RangeSelector":
                var d = b;
                if (d != null) {
                    d.rangeChanged = delegateRemove(d.rangeChanged, runOn(this, this.bj));
                }
                if (this.s != null) {
                    this.s.t = this.as;
                    this.s.s = this.ar;
                    this.s.o = this.u;
                    this.s.v = this.au;
                    this.s.u = this.at;
                    var e = this.s;
                    e.rangeChanged = delegateCombine(e.rangeChanged, runOn(this, this.bj));
                }
                break;
            case "ChartTypePicker":
                var f = b;
                if (f != null) {
                    f.selectionChanged = delegateRemove(f.selectionChanged, runOn(this, this.bi));
                }
                if (this.aa != null) {
                    this.aa.w = this.y;
                    var g = this.aa;
                    g.selectionChanged = delegateCombine(g.selectionChanged, runOn(this, this.bi));
                }
                break;
            case "ChartType":
                if (this.aa != null) {
                    this.aa.w = this.y;
                }
                break;
            case "RangeSelectorOptions":
                if (this.s != null) {
                    this.s.o = this.u;
                }
                break;
            case "IsToolbarVisible":
                if (this.g == null) {
                    break;
                }
                if (this.al) {
                    this.g.show();
                }
                else {
                    this.g.hide();
                }
                break;
            case "IndicatorMenu":
                var h = typeCast(FinancialChartIndicatorMenu.$, b);
                if (h != null) {
                    h.selectionChanged = delegateRemove(h.selectionChanged, runOn(this, this.bh));
                }
                if (this.q != null) {
                    var i = this.q;
                    i.selectionChanged = delegateCombine(i.selectionChanged, runOn(this, this.bh));
                }
                break;
            case "IndicatorTypes":
                if (this.indicatorTypesChanged != null) {
                    this.indicatorTypesChanged(this, EventArgs.empty);
                }
                break;
            case "OverlayTypes":
                if (this.overlayTypesChanged != null) {
                    this.overlayTypesChanged(this, EventArgs.empty);
                }
                break;
            case "TrendLineType":
                if (this.trendLineTypeChanged != null) {
                    this.trendLineTypeChanged(this, EventArgs.empty);
                }
                break;
            case "VolumeType":
                if (this.volumeTypeChanged != null) {
                    this.volumeTypeChanged(this, EventArgs.empty);
                }
                break;
        }
    };
    FinancialChartToolbar.prototype.bh = function (a, b) {
        this.ag = this.q.z;
        this.ae = this.q.y;
        this.ai = this.q.aa;
        this.ac = this.q.x;
    };
    FinancialChartToolbar.prototype.bi = function (a, b) {
        this.y = this.aa.w;
        if (this.chartTypeChanged != null) {
            this.chartTypeChanged(this, b);
        }
    };
    FinancialChartToolbar.prototype.bj = function (a, b) {
        this.au = this.s.v;
        this.at = this.s.u;
        if (this.rangeChanged != null) {
            this.rangeChanged(this, b);
        }
    };
    FinancialChartToolbar.prototype.v = function () {
        var _this = this;
        var a = new FinancialChartToolbarContext();
        a.container = this.d;
        a.vm = this.w;
        a.vm.financialChartIndicatorMenu = ((function () {
            var $ret = new FinancialChartIndicatorMenuContext();
            $ret.vm = _this.q.p;
            return $ret;
        })());
        a.vm.financialChartTypePicker = ((function () {
            var $ret = new FinancialChartTypePickerContext();
            $ret.vm = _this.aa.p;
            return $ret;
        })());
        a.vm.financialChartRangeSelector = ((function () {
            var $ret = new FinancialChartRangeSelectorContext();
            $ret.vm = _this.s.q;
            return $ret;
        })());
        return a;
    };
    FinancialChartToolbar.prototype.l = function (a) {
        _super.prototype.l.call(this, a);
        if (a == null) {
            return;
        }
        this.s.l(a);
        this.aa.l(a);
        this.q.l(a);
        this.bk();
    };
    FinancialChartToolbar.prototype.bk = function () {
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "au", {
        get: function () {
            return this.aq;
        },
        set: function (a) {
            var b = this.au;
            if (+a != +b) {
                this.aq = a;
                this.bm("SelectionStart", b, this.au);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "at", {
        get: function () {
            return this.ap;
        },
        set: function (a) {
            var b = this.at;
            if (+a != +b) {
                this.ap = a;
                this.bm("SelectionEnd", b, this.at);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "as", {
        get: function () {
            return this.ao;
        },
        set: function (a) {
            var b = this.as;
            if (+a != +b) {
                this.ao = a;
                this.bm("RangeStart", b, this.as);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ar", {
        get: function () {
            return this.an;
        },
        set: function (a) {
            var b = this.ar;
            if (+a != +b) {
                this.an = a;
                this.bm("RangeEnd", b, this.ar);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChartToolbar.prototype.bn = function () {
        if (this.s != null) {
            this.s.ab();
        }
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "y", {
        get: function () {
            return this.x;
        },
        set: function (a) {
            var b = this.y;
            if (a != b) {
                this.x = a;
                this.bm("ChartType", enumGetBox(FinancialChartType_$type, b), enumGetBox(FinancialChartType_$type, this.y));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ai", {
        get: function () {
            return this.ah;
        },
        set: function (a) {
            var b = this.ai;
            if (a != b) {
                this.ah = a;
                this.bm("TrendLineType", enumGetBox(TrendLineType_$type, b), enumGetBox(TrendLineType_$type, this.ai));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ac", {
        get: function () {
            return this.ab;
        },
        set: function (a) {
            var b = this.ac;
            if (a != b) {
                this.ab = a;
                this.bm("VolumeType", enumGetBox(FinancialChartVolumeType_$type, b), enumGetBox(FinancialChartVolumeType_$type, this.ac));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ae", {
        get: function () {
            return this.ad;
        },
        set: function (a) {
            var b = this.ae;
            if (!FinancialChartToolbar.am(b, a)) {
                this.ad = a;
                this.bm("IndicatorTypes", b, this.ae);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "ag", {
        get: function () {
            return this.af;
        },
        set: function (a) {
            var b = this.ag;
            if (!FinancialChartToolbar.am(b, a)) {
                this.af = a;
                this.bm("OverlayTypes", b, this.ag);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChartToolbar.am = function (a, b) {
        var e_21, _a;
        if (a == b) {
            return true;
        }
        if ((a == null && b != null) || (a != null && b == null)) {
            return false;
        }
        if (a.count != b.count) {
            return false;
        }
        try {
            for (var _b = __values(fromEn(a)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                if (!b.contains(c)) {
                    return false;
                }
            }
        }
        catch (e_21_1) {
            e_21 = { error: e_21_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_21)
                    throw e_21.error;
            }
        }
        return true;
    };
    FinancialChartToolbar.prototype.aj = function () {
        var _this = this;
        return ((function () {
            var $ret = new FinancialChartToolbarVisualData();
            $ret.rangeSelector = _this.s == null ? null : _this.s.r();
            return $ret;
        })());
    };
    Object.defineProperty(FinancialChartToolbar.prototype, "u", {
        get: function () {
            return this.t;
        },
        set: function (a) {
            var b = this.u;
            if (a != b) {
                this.t = a;
                this.bm("RangeSelectorOptions", b, this.u);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartToolbar.prototype, "al", {
        get: function () {
            return this.ak;
        },
        set: function (a) {
            var b = this.al;
            if (a != b) {
                this.ak = a;
                this.bm("IsToolbarVisible", b, this.al);
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChartToolbar.$t = markType(FinancialChartToolbar, 'FinancialChartToolbar', TemplatedHtmlControl.$);
    return FinancialChartToolbar;
}(TemplatedHtmlControl));
export { FinancialChartToolbar };
/**
 * @hidden
 */
var FinancialChartRangeSelector = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(FinancialChartRangeSelector, _super);
    function FinancialChartRangeSelector(a) {
        var _this = _super.call(this, "financialChartRangeSelector", a, "") || this;
        _this.q = null;
        _this.rangeChanged = null;
        _this.p = null;
        _this.p = new FinancialChartRangeSelectorView();
        _this.q = new FinancialChartRangeSelectorViewModel();
        _this.q.onRangeChanged = runOn(_this, _this.z);
        _this.p.c = _this.q;
        return _this;
    }
    Object.defineProperty(FinancialChartRangeSelector.prototype, "v", {
        get: function () {
            return this.q.selectionStart;
        },
        set: function (a) {
            this.q.selectionStart = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelector.prototype, "u", {
        get: function () {
            return this.q.selectionEnd;
        },
        set: function (a) {
            this.q.selectionEnd = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelector.prototype, "t", {
        get: function () {
            return this.q.rangeStart;
        },
        set: function (a) {
            this.q.rangeStart = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(FinancialChartRangeSelector.prototype, "s", {
        get: function () {
            return this.q.rangeEnd;
        },
        set: function (a) {
            this.q.rangeEnd = a;
        },
        enumerable: false,
        configurable: true
    });
    FinancialChartRangeSelector.prototype.ab = function () {
        if (this.q.onPropertiesChanged()) {
            this.p.g(this.q);
        }
    };
    FinancialChartRangeSelector.prototype.l = function (a) {
        _super.prototype.l.call(this, a);
        this.p.f(this.d, this.q);
    };
    FinancialChartRangeSelector.prototype.z = function () {
        if (this.rangeChanged != null) {
            this.rangeChanged(this, EventArgs.empty);
        }
    };
    FinancialChartRangeSelector.prototype.r = function () {
        return this.p.d(this.g);
    };
    Object.defineProperty(FinancialChartRangeSelector.prototype, "o", {
        get: function () {
            return this.q.options;
        },
        set: function (a) {
            var b = !FinancialChartToolbar.am(this.q.options, a);
            if (b) {
                this.q.options = a;
                this.aa();
            }
        },
        enumerable: false,
        configurable: true
    });
    FinancialChartRangeSelector.prototype.aa = function () {
        if (this.q != null) {
            this.q.ao();
        }
        if (this.p != null) {
            this.p.i(this.o);
        }
    };
    FinancialChartRangeSelector.$t = markType(FinancialChartRangeSelector, 'FinancialChartRangeSelector', TemplatedHtmlControl.$);
    FinancialChartRangeSelector.x = 0;
    return FinancialChartRangeSelector;
}(TemplatedHtmlControl));
export { FinancialChartRangeSelector };
