/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { DomainChart } from "./DomainChart";
import { fromEnum, enumGetBox, markType } from "igniteui-react-core";
import { HorizontalAlignment_$type } from "igniteui-react-core";
import { VerticalAlignment_$type } from "igniteui-react-core";
import { Visibility_$type } from "igniteui-react-core";
import { YAxisLabelLocation_$type } from "./YAxisLabelLocation";
import { XAxisLabelLocation_$type } from "./XAxisLabelLocation";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { AxisDefaults } from "./AxisDefaults";
import { TitleSettings } from "./TitleSettings";
import { ScalerParams } from "./ScalerParams";
import { DeviceUtils } from "igniteui-react-core";
/**
 * @hidden
 */
var XYChart = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(XYChart, _super);
    function XYChart() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.vh = null;
        _this.vi = null;
        _this.vy = 0;
        _this.v0 = 5;
        _this.vz = 0;
        _this.vx = 5;
        _this.wf = 5;
        _this.wh = 0;
        _this.wg = 5;
        _this.we = 0;
        _this.aa8 = null;
        _this.abf = null;
        _this.aa6 = null;
        _this.aa7 = null;
        _this.v9 = 0;
        _this.wq = 0;
        _this.v8 = NaN;
        _this.wp = NaN;
        _this.wb = NaN;
        _this.ws = NaN;
        _this.wa = NaN;
        _this.wr = NaN;
        _this.v7 = NaN;
        _this.wo = NaN;
        _this.abe = null;
        _this.abl = null;
        _this.x0 = null;
        _this.x4 = null;
        _this.x2 = null;
        _this.x6 = null;
        _this.xv = null;
        _this.xw = null;
        _this.aa9 = null;
        _this.abg = null;
        _this.v1 = DeviceUtils.g(1);
        _this.wi = DeviceUtils.g(1);
        _this.v2 = DeviceUtils.g(1);
        _this.wj = DeviceUtils.g(1);
        _this.abb = null;
        _this.abi = null;
        _this.abc = null;
        _this.abj = null;
        _this.v3 = DeviceUtils.g(1);
        _this.wk = DeviceUtils.g(1);
        _this.v4 = DeviceUtils.g(8);
        _this.wl = 0;
        _this.abd = null;
        _this.abk = null;
        _this.v5 = DeviceUtils.g(1);
        _this.wm = DeviceUtils.g(1);
        _this.x1 = null;
        _this.x5 = null;
        _this.aba = null;
        _this.abh = null;
        _this.vw = 0;
        _this.wd = 0;
        _this.vv = NaN;
        _this.wc = NaN;
        _this.v6 = 0;
        _this.wn = -90;
        _this.vr = false;
        _this.vs = false;
        _this.aa1 = 1;
        _this.ab4 = 1;
        _this.aa0 = 1;
        _this.aa2 = 2;
        _this.ab2 = 0;
        _this.ab3 = 1;
        _this.ab8 = 0;
        _this.ab9 = 0;
        _this.vp = 4;
        _this.vn = 4;
        _this.xz = null;
        _this.vb = null;
        _this.x3 = null;
        _this.vc = null;
        return _this;
    }
    XYChart.prototype.provideContainer = function (a) {
        if (a != null) {
            var b = this.vf();
            var c = this.vg();
            if (b != null) {
                b.provideRenderer(a);
            }
            if (c != null) {
                c.provideRenderer(a);
            }
        }
        _super.prototype.provideContainer.call(this, a);
    };
    XYChart.prototype.rq = function () {
        _super.prototype.rq.call(this);
        var a = this.vf();
        var b = this.vg();
        if (a != null && a.ay != null) {
            this.abo = a.ay.textColor;
        }
        if (b != null && b.ay != null) {
            this.abv = b.ay.textColor;
        }
        this.abt = AxisDefaults.j;
        this.ab0 = AxisDefaults.j;
        this.abp = AxisDefaults.h;
        this.abw = AxisDefaults.h;
        this.abs = AxisDefaults.g;
        this.abz = AxisDefaults.g;
    };
    XYChart.prototype.sd = function (a, b, c) {
        var _this = this;
        _super.prototype.sd.call(this, a, b, c);
        switch (a) {
            case "XAxisLabelLeftMargin":
                this.aas(function (d) { return d.leftMargin = _this.w0; });
                break;
            case "XAxisLabelTopMargin":
                this.aas(function (d) { return d.topMargin = _this.w2; });
                break;
            case "XAxisLabelRightMargin":
                this.aas(function (d) { return d.rightMargin = _this.w1; });
                break;
            case "XAxisLabelBottomMargin":
                this.aas(function (d) { return d.bottomMargin = _this.wz; });
                break;
            case "YAxisLabelLeftMargin":
                this.aax(function (d) { return d.leftMargin = _this.xh; });
                break;
            case "YAxisLabelTopMargin":
                this.aax(function (d) { return d.topMargin = _this.xj; });
                break;
            case "YAxisLabelRightMargin":
                this.aax(function (d) { return d.rightMargin = _this.xi; });
                break;
            case "YAxisLabelBottomMargin":
                this.aax(function (d) { return d.bottomMargin = _this.xg; });
                break;
            case "ActualItemsSource":
            case "ShouldDisplayMockData":
            case "ShouldUseSkeletonStyleForMockData":
                this.abm = this.ui(this.abo);
                this.abn = this.ui(this.abv);
                break;
            case "XAxisLabelTextColor":
                this.abm = this.ui(this.abo);
                break;
            case "YAxisLabelTextColor":
                this.abn = this.ui(this.abv);
                break;
            case "ActualXAxisLabelTextColor":
                this.aas(function (d) { return d.textColor = _this.abm; });
                break;
            case "ActualYAxisLabelTextColor":
                this.aax(function (d) { return d.textColor = _this.abn; });
                break;
            case "XAxisTitleMargin":
                this.aau(function (d) { return d.margin = _this.xb; });
                break;
            case "YAxisTitleMargin":
                this.aaz(function (d) { return d.margin = _this.xs; });
                break;
            case "XAxisTitleLeftMargin":
                this.aau(function (d) { return d.leftMargin = _this.xa; });
                break;
            case "YAxisTitleLeftMargin":
                this.aaz(function (d) { return d.leftMargin = _this.xr; });
                break;
            case "XAxisTitleTopMargin":
                this.aau(function (d) { return d.topMargin = _this.xd; });
                break;
            case "YAxisTitleTopMargin":
                this.aaz(function (d) { return d.topMargin = _this.xu; });
                break;
            case "XAxisTitleRightMargin":
                this.aau(function (d) { return d.rightMargin = _this.xc; });
                break;
            case "YAxisTitleRightMargin":
                this.aaz(function (d) { return d.rightMargin = _this.xt; });
                break;
            case "XAxisTitleBottomMargin":
                this.aau(function (d) { return d.bottomMargin = _this.w9; });
                break;
            case "YAxisTitleBottomMargin":
                this.aaz(function (d) { return d.bottomMargin = _this.xq; });
                break;
            case "XAxisTitleTextColor":
                this.aau(function (d) { return d.textColor = _this.abu; });
                break;
            case "YAxisTitleTextColor":
                this.aaz(function (d) { return d.textColor = _this.ab1; });
                break;
            case "XAxisFormatLabel":
                this.aaq(function (d) { return d.at = _this.vj; });
                break;
            case "YAxisFormatLabel":
                this.aav(function (d) { return d.at = _this.vk; });
                break;
        }
    };
    Object.defineProperty(XYChart.prototype, "vj", {
        get: function () {
            return this.vh;
        },
        set: function (a) {
            var b = this.vj;
            if (a != b) {
                this.vh = a;
                this.sc("XAxisFormatLabel", b, this.vj);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "vk", {
        get: function () {
            return this.vi;
        },
        set: function (a) {
            var b = this.vk;
            if (a != b) {
                this.vi = a;
                this.sc("YAxisFormatLabel", b, this.vk);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "w0", {
        get: function () {
            return this.vy;
        },
        set: function (a) {
            var b = this.w0;
            if (a != b) {
                this.vy = a;
                this.sc("XAxisLabelLeftMargin", b, this.w0);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "w2", {
        get: function () {
            return this.v0;
        },
        set: function (a) {
            var b = this.w2;
            if (a != b) {
                this.v0 = a;
                this.sc("XAxisLabelTopMargin", b, this.w2);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "w1", {
        get: function () {
            return this.vz;
        },
        set: function (a) {
            var b = this.w1;
            if (a != b) {
                this.vz = a;
                this.sc("XAxisLabelRightMargin", b, this.w1);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "wz", {
        get: function () {
            return this.vx;
        },
        set: function (a) {
            var b = this.wz;
            if (a != b) {
                this.vx = a;
                this.sc("XAxisLabelBottomMargin", b, this.wz);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xh", {
        get: function () {
            return this.wf;
        },
        set: function (a) {
            var b = this.xh;
            if (a != b) {
                this.wf = a;
                this.sc("YAxisLabelLeftMargin", b, this.xh);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xj", {
        get: function () {
            return this.wh;
        },
        set: function (a) {
            var b = this.xj;
            if (a != b) {
                this.wh = a;
                this.sc("YAxisLabelTopMargin", b, this.xj);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xi", {
        get: function () {
            return this.wg;
        },
        set: function (a) {
            var b = this.xi;
            if (a != b) {
                this.wg = a;
                this.sc("YAxisLabelRightMargin", b, this.xi);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xg", {
        get: function () {
            return this.we;
        },
        set: function (a) {
            var b = this.xg;
            if (a != b) {
                this.we = a;
                this.sc("YAxisLabelBottomMargin", b, this.xg);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "abo", {
        get: function () {
            return this.aa8;
        },
        set: function (a) {
            var b = this.abo;
            if (a != b) {
                this.aa8 = a;
                this.sc("XAxisLabelTextColor", b, this.abo);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "abv", {
        get: function () {
            return this.abf;
        },
        set: function (a) {
            var b = this.abv;
            if (a != b) {
                this.abf = a;
                this.sc("YAxisLabelTextColor", b, this.abv);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "abm", {
        get: function () {
            return this.aa6;
        },
        set: function (a) {
            var b = this.aa6;
            if (a != b) {
                this.aa6 = a;
                this.sc("ActualXAxisLabelTextColor", b, this.abm);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "abn", {
        get: function () {
            return this.aa7;
        },
        set: function (a) {
            var b = this.aa7;
            if (a != b) {
                this.aa7 = a;
                this.sc("ActualYAxisLabelTextColor", b, this.abn);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xb", {
        get: function () {
            return this.v9;
        },
        set: function (a) {
            var b = this.xb;
            if (a != b) {
                this.v9 = a;
                this.sc("XAxisTitleMargin", b, this.xb);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xs", {
        get: function () {
            return this.wq;
        },
        set: function (a) {
            var b = this.xs;
            if (a != b) {
                this.wq = a;
                this.sc("YAxisTitleMargin", b, this.xs);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xa", {
        get: function () {
            return this.v8;
        },
        set: function (a) {
            var b = this.xa;
            if (a != b) {
                this.v8 = a;
                this.sc("XAxisTitleLeftMargin", b, this.xa);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xr", {
        get: function () {
            return this.wp;
        },
        set: function (a) {
            var b = this.xr;
            if (a != b) {
                this.wp = a;
                this.sc("YAxisTitleLeftMargin", b, this.xr);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xd", {
        get: function () {
            return this.wb;
        },
        set: function (a) {
            var b = this.xd;
            if (a != b) {
                this.wb = a;
                this.sc("XAxisTitleTopMargin", b, this.xd);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xu", {
        get: function () {
            return this.ws;
        },
        set: function (a) {
            var b = this.xu;
            if (a != b) {
                this.ws = a;
                this.sc("YAxisTitleTopMargin", b, this.xu);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xc", {
        get: function () {
            return this.wa;
        },
        set: function (a) {
            var b = this.xc;
            if (a != b) {
                this.wa = a;
                this.sc("XAxisTitleRightMargin", b, this.xc);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xt", {
        get: function () {
            return this.wr;
        },
        set: function (a) {
            var b = this.xt;
            if (a != b) {
                this.wr = a;
                this.sc("YAxisTitleRightMargin", b, this.xt);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "w9", {
        get: function () {
            return this.v7;
        },
        set: function (a) {
            var b = this.w9;
            if (a != b) {
                this.v7 = a;
                this.sc("XAxisTitleBottomMargin", b, this.w9);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xq", {
        get: function () {
            return this.wo;
        },
        set: function (a) {
            var b = this.xq;
            if (a != b) {
                this.wo = a;
                this.sc("YAxisTitleBottomMargin", b, this.xq);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "abu", {
        get: function () {
            return this.abe;
        },
        set: function (a) {
            var b = this.abu;
            if (a != b) {
                this.abe = a;
                this.sc("XAxisTitleTextColor", b, this.abu);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ab1", {
        get: function () {
            return this.abl;
        },
        set: function (a) {
            var b = this.ab1;
            if (a != b) {
                this.abl = a;
                this.sc("YAxisTitleTextColor", b, this.ab1);
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.se = function (a, b, c) {
        var _this = this;
        _super.prototype.se.call(this, a, b, c);
        switch (a) {
            case "XAxisLabelTextStyle":
                this.aas(function (d) { return d.textStyle = _this.yo; });
                break;
            case "YAxisLabelTextStyle":
                this.aax(function (d) { return d.textStyle = _this.zt; });
                break;
            case "XAxisTitleTextStyle":
                this.aau(function (d) { return d.textStyle = _this.zc; });
                break;
            case "YAxisTitleTextStyle":
                this.aaz(function (d) { return d.textStyle = _this.aah; });
                break;
        }
    };
    Object.defineProperty(XYChart.prototype, "yo", {
        get: function () {
            return this.x0;
        },
        set: function (a) {
            var b = this.yo;
            if (a != b) {
                this.x0 = a;
                this.sc("XAxisLabelTextStyle", b, this.yo);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "zt", {
        get: function () {
            return this.x4;
        },
        set: function (a) {
            var b = this.zt;
            if (a != b) {
                this.x4 = a;
                this.sc("YAxisLabelTextStyle", b, this.zt);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "zc", {
        get: function () {
            return this.x2;
        },
        set: function (a) {
            var b = this.zc;
            if (a != b) {
                this.x2 = a;
                this.sc("XAxisTitleTextStyle", b, this.zc);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aah", {
        get: function () {
            return this.x6;
        },
        set: function (a) {
            var b = this.aah;
            if (a != b) {
                this.x6 = a;
                this.sc("YAxisTitleTextStyle", b, this.aah);
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.aan = function (a) {
        var _this = this;
        this.aak(a, function (b) { return b.leftMargin = _this.w0; });
        this.aak(a, function (b) { return b.topMargin = _this.w2; });
        this.aak(a, function (b) { return b.rightMargin = _this.w1; });
        this.aak(a, function (b) { return b.bottomMargin = _this.wz; });
        this.aak(a, function (b) { return b.textColor = _this.abm; });
        this.aal(a, function (b) { return b.textColor = _this.abu; });
        this.aal(a, function (b) { return b.leftMargin = _this.xa; });
        this.aal(a, function (b) { return b.topMargin = _this.xd; });
        this.aal(a, function (b) { return b.rightMargin = _this.xc; });
        this.aal(a, function (b) { return b.bottomMargin = _this.w9; });
        this.aak(a, function (b) { return b.textStyle = _this.yo; });
        this.aal(a, function (b) { return b.textStyle = _this.zc; });
    };
    XYChart.prototype.aap = function (a) {
        var _this = this;
        this.aak(a, function (b) { return b.leftMargin = _this.xh; });
        this.aak(a, function (b) { return b.topMargin = _this.xj; });
        this.aak(a, function (b) { return b.rightMargin = _this.xi; });
        this.aak(a, function (b) { return b.bottomMargin = _this.xg; });
        this.aak(a, function (b) { return b.textColor = _this.abn; });
        this.aal(a, function (b) { return b.textColor = _this.ab1; });
        this.aal(a, function (b) { return b.leftMargin = _this.xr; });
        this.aal(a, function (b) { return b.topMargin = _this.xu; });
        this.aal(a, function (b) { return b.rightMargin = _this.xt; });
        this.aal(a, function (b) { return b.bottomMargin = _this.xq; });
        this.aak(a, function (b) { return b.textStyle = _this.zt; });
        this.aal(a, function (b) { return b.textStyle = _this.aah; });
    };
    XYChart.prototype.sv = function (a) {
        var b = this.a9(a);
        var c = this.cv(a, b);
        if (c == null) {
            return;
        }
        c.itemsSource = a.data;
        c.name = this.ny(a);
        c.title = this.nz(a, b);
        this.dataChart.series.add(c);
    };
    XYChart.prototype.aaq = function (a) {
        this.aar(a, null);
    };
    XYChart.prototype.aar = function (a, b) {
        a(this.vf());
    };
    XYChart.prototype.aaw = function (a, b) {
        a(this.vg());
    };
    XYChart.prototype.aav = function (a) {
        this.aaw(a, true);
    };
    XYChart.prototype.ra = function (a, b) {
        this.aaq(a);
        this.aaw(a, b);
    };
    XYChart.prototype.aau = function (a) {
        this.aal(this.vf(), a);
    };
    XYChart.prototype.aaz = function (a) {
        this.aal(this.vg(), a);
    };
    XYChart.prototype.aax = function (a) {
        this.aak(this.vg(), a);
    };
    XYChart.prototype.aas = function (a) {
        this.aak(this.vf(), a);
    };
    XYChart.prototype.wt = function (a) {
        var b = this.vf();
        return b.ei(a, new ScalerParams(1, this.uq, this.up, b.cg));
    };
    XYChart.prototype.wv = function (a) {
        var b = this.vf();
        return b.el(a, new ScalerParams(1, this.uq, this.up, b.cg));
    };
    XYChart.prototype.wu = function (a) {
        var b = this.vg();
        return b.ei(a, new ScalerParams(1, this.uq, this.up, b.cg));
    };
    XYChart.prototype.ww = function (a) {
        var b = this.vg();
        return b.el(a, new ScalerParams(1, this.uq, this.up, b.cg));
    };
    XYChart.prototype.ss = function (a) {
        _super.prototype.ss.call(this, a);
        if (a == null) {
            return;
        }
        if (a.axes != null) {
            var b = this.vf();
            var c = this.vg();
            if (a.axes.contains(b)) {
                a.axes.remove(b);
            }
            if (a.axes.contains(c)) {
                a.axes.remove(c);
            }
        }
    };
    XYChart.x9 = function (a, b) {
        var e_1, _a;
        try {
            for (var _b = __values(fromEnum(b)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                var d = c.findMatchingHint(16);
                if (d != null) {
                    var e = d.path;
                    return e;
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return null;
    };
    XYChart.prototype.rl = function (a) {
        _super.prototype.rl.call(this, a);
        if (a == this.dataChart) {
            this.dataChart.axes.add(this.vf());
            this.dataChart.axes.add(this.vg());
        }
    };
    XYChart.prototype.aam = function (a) {
        var _this = this;
        if (a != null && this.jt != null && a.fk == null) {
            a.provideRenderer(this.jt);
        }
        a.jv = this.abp;
        a.eq = this.w3;
        a.jw = this.abq;
        a.et = this.w4;
        a.jy = this.abs;
        a.ff = this.w5;
        a.jx = this.abr;
        a.fg = this.w6;
        a.jz = this.abt;
        a.fh = this.w7;
        a.c3 = true;
        a.ct = this.fz;
        a.cv = this.fz;
        var b = a == this.vf();
        if (b) {
            a.g5 = this.y3;
        }
        a.fz = this.xx;
        a.gf = this.yf;
        a.ag = this.vd;
        this.aak(a, function (c) { return c.angle = _this.wy; });
        this.aak(a, function (c) {
            if (c.extent != _this.wx) {
                c.extent = _this.wx;
            }
        });
        this.aak(a, function (c) { return c.horizontalAlignment = _this.aa3; });
        this.aak(a, function (c) { return c.verticalAlignment = _this.ab5; });
        this.aak(a, function (c) { return c.visibility = _this.aca; });
        this.aak(a, function (c) { return c.location = _this.vl(_this.vo); });
        this.aal(a, function (c) { return c.horizontalAlignment = _this.aa4; });
        this.aal(a, function (c) { return c.angle = _this.w8; });
        this.aan(a);
    };
    XYChart.prototype.aao = function (a) {
        var _this = this;
        if (a == null) {
            return;
        }
        if (this.jt != null && a.fk == null) {
            a.provideRenderer(this.jt);
        }
        a.ct = this.fz;
        a.cv = this.fz;
        this.aak(a, function (b) { return b.angle = _this.xf; });
        this.aak(a, function (b) {
            if (b.extent != _this.xe) {
                b.extent = _this.xe;
            }
        });
        this.aak(a, function (b) { return b.horizontalAlignment = _this.aa5; });
        this.aak(a, function (b) { return b.verticalAlignment = _this.ab6; });
        this.aak(a, function (b) { return b.visibility = _this.acb; });
        this.aak(a, function (b) { return b.location = _this.vm(_this.vq); });
        this.aal(a, function (b) { return b.verticalAlignment = _this.ab7; });
        this.aal(a, function (b) { return b.angle = _this.xp; });
        a.jv = this.abw;
        a.eq = this.xk;
        a.jw = this.abx;
        a.et = this.xl;
        a.jy = this.abz;
        a.ff = this.xm;
        a.jx = this.aby;
        a.fg = this.xn;
        a.jz = this.ab0;
        a.fh = this.xo;
        var b = a == this.vg();
        if (b) {
            a.g5 = this.z8;
        }
        a.gf = this.zk;
        a.ag = this.ve;
        this.aap(a);
    };
    XYChart.prototype.ri = function () {
        _super.prototype.ri.call(this);
        this.aam(this.vf());
        this.aao(this.vg());
    };
    XYChart.prototype.aak = function (a, b) {
        if (a == null) {
            return;
        }
        if (a.ay == null) {
            a.ay = new AxisLabelSettings();
            a.ay.angle = a.d4();
            a.ay.bottomMargin = a.d5();
            a.ay.leftMargin = a.d6();
            a.ay.rightMargin = a.d7();
            a.ay.topMargin = a.d8();
            a.ay.horizontalAlignment = a.jq();
            a.ay.location = a.az();
            a.ay.verticalAlignment = a.kj();
        }
        b(a.ay);
    };
    XYChart.prototype.aal = function (a, b) {
        if (a == null) {
            return;
        }
        if (a.be == null) {
            a.be = new TitleSettings();
            a.be.bottomMargin = a.ea();
            a.be.leftMargin = a.eb();
            a.be.rightMargin = a.ec();
            a.be.topMargin = a.ed();
            a.be.location = a.a0();
            a.be.angle = a.d9();
            a.be.horizontalAlignment = a.jr();
            a.be.verticalAlignment = a.kk();
        }
        b(a.be);
    };
    XYChart.prototype.sc = function (a, b, c) {
        var _this = this;
        _super.prototype.sc.call(this, a, b, c);
        switch (a) {
            case "XAxisLabelAngle":
                this.aas(function (d) { return d.angle = _this.wy; });
                break;
            case "YAxisLabelAngle":
                this.aax(function (d) { return d.angle = _this.xf; });
                break;
            case "XAxisLabelHorizontalAlignment":
                this.aas(function (d) { return d.horizontalAlignment = _this.aa3; });
                break;
            case "YAxisLabelHorizontalAlignment":
                this.aax(function (d) { return d.horizontalAlignment = _this.aa5; });
                break;
            case "XAxisLabelVerticalAlignment":
                this.aas(function (d) { return d.verticalAlignment = _this.ab5; });
                break;
            case "YAxisLabelVerticalAlignment":
                this.aax(function (d) { return d.verticalAlignment = _this.ab6; });
                break;
            case "XAxisLabelVisibility":
                this.aas(function (d) { return d.visibility = _this.aca; });
                break;
            case "YAxisLabelVisibility":
                this.aax(function (d) { return d.visibility = _this.acb; });
                break;
            case "XAxisLabel":
                this.aaq(function (d) { return d.fz = _this.xx; });
                break;
            case "YAxisLabel":
                this.aav(function (d) { return d.fz = _this.xy; });
                break;
            case "XAxisLabelFormat":
                this.aaq(function (d) { return d.gf = _this.yf; });
                break;
            case "XAxisLabelFormatSpecifiers":
                this.aaq(function (d) { return d.ag = _this.vd; });
                break;
            case "YAxisLabelFormat":
                this.aav(function (d) { return d.gf = _this.zk; });
                break;
            case "YAxisLabelFormatSpecifiers":
                this.aav(function (d) { return d.ag = _this.ve; });
                break;
            case "XAxisTitleAngle":
                this.aau(function (d) { return d.angle = _this.w8; });
                break;
            case "YAxisTitleAngle":
                this.aaz(function (d) { return d.angle = _this.xp; });
                break;
            case "XAxisTitleAlignment":
                this.aau(function (d) { return d.horizontalAlignment = _this.aa4; });
                break;
            case "YAxisTitleAlignment":
                this.aaz(function (d) { return d.verticalAlignment = _this.ab7; });
                break;
            case "XAxisTitle":
                this.aaq(function (d) { return d.g5 = _this.y3; });
                break;
            case "YAxisTitle":
                this.aaw(function (d) { return d.g5 = _this.z8; }, false);
                break;
            case "XAxisMajorStroke":
                this.aar(function (d) { return d.jv = _this.abp; }, a);
                break;
            case "YAxisMajorStroke":
                this.aav(function (d) { return d.jv = _this.abw; });
                break;
            case "XAxisMajorStrokeThickness":
                this.aar(function (d) { return d.eq = _this.w3; }, a);
                break;
            case "YAxisMajorStrokeThickness":
                this.aav(function (d) { return d.eq = _this.xk; });
                break;
            case "XAxisMinorStroke":
                this.aaq(function (d) { return d.jw = _this.abq; });
                break;
            case "YAxisMinorStroke":
                this.aav(function (d) { return d.jw = _this.abx; });
                break;
            case "XAxisMinorStrokeThickness":
                this.aaq(function (d) { return d.et = _this.w4; });
                break;
            case "YAxisMinorStrokeThickness":
                this.aav(function (d) { return d.et = _this.xl; });
                break;
            case "XAxisTickLength":
                this.aaq(function (d) { return d.fg = _this.w6; });
                break;
            case "YAxisTickLength":
                this.aav(function (d) { return d.fg = _this.xn; });
                break;
            case "XAxisTickStroke":
                this.aaq(function (d) { return d.jz = _this.abt; });
                break;
            case "YAxisTickStroke":
                this.aav(function (d) { return d.jz = _this.ab0; });
                break;
            case "XAxisTickStrokeThickness":
                this.aaq(function (d) { return d.fh = _this.w7; });
                break;
            case "YAxisTickStrokeThickness":
                this.aav(function (d) { return d.fh = _this.xo; });
                break;
            case "XAxisStroke":
                this.aaq(function (d) { return d.jy = _this.abs; });
                break;
            case "YAxisStroke":
                this.aav(function (d) { return d.jy = _this.abz; });
                break;
            case "XAxisStrokeThickness":
                this.aaq(function (d) { return d.ff = _this.w5; });
                break;
            case "YAxisStrokeThickness":
                this.aav(function (d) { return d.ff = _this.xm; });
                break;
            case "XAxisExtent":
                this.aas(function (d) { return d.extent = _this.wx; });
                break;
            case "YAxisExtent":
                this.aax(function (d) { return d.extent = _this.xe; });
                break;
            case "XAxisStrip":
                this.aaq(function (d) { return d.jx = _this.abr; });
                break;
            case "YAxisStrip":
                this.aav(function (d) { return d.jx = _this.aby; });
                break;
            case "XAxisInverted":
                this.aaq(function (d) { return d.cg = _this.vt; });
                break;
            case "YAxisInverted":
                this.aav(function (d) { return d.cg = _this.vu; });
                break;
            case "YAxisLabelLocation":
                this.aay();
                break;
            case "XAxisLabelLocation":
                this.aat();
                break;
        }
    };
    XYChart.prototype.aay = function () {
        var a = this.vm(this.vq);
        if (a == 2 || a == 7) {
            this.aa5 = 2;
        }
        else {
            this.aa5 = 0;
        }
        this.aax(function (b) { return b.location = a; });
    };
    XYChart.prototype.aat = function () {
        var a = this.vl(this.vo);
        if (a == 1 || a == 5) {
            this.ab5 = 0;
        }
        else {
            this.ab5 = 2;
        }
        this.aas(function (b) { return b.location = a; });
    };
    XYChart.prototype.vm = function (a) {
        if (a == 0) {
            return 2;
        }
        else if (a == 1) {
            return 3;
        }
        else if (a == 3) {
            return 7;
        }
        else if (a == 2) {
            return 6;
        }
        else {
            if (this.by == 1) {
                return 3;
            }
            else {
                return 2;
            }
        }
    };
    XYChart.prototype.vl = function (a) {
        if (a == 1) {
            return 1;
        }
        else if (a == 0) {
            return 0;
        }
        else if (a == 3) {
            return 5;
        }
        else if (a == 2) {
            return 4;
        }
        else {
            return 1;
        }
    };
    Object.defineProperty(XYChart.prototype, "xx", {
        get: function () {
            return this.xv;
        },
        set: function (a) {
            var b = this.xx;
            if (a != b) {
                this.xv = a;
                this.sc("XAxisLabel", b, this.xx);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xy", {
        get: function () {
            return this.xw;
        },
        set: function (a) {
            var b = this.xy;
            if (a != b) {
                this.xw = a;
                this.sc("YAxisLabel", b, this.xy);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "abp", {
        get: function () {
            return this.aa9;
        },
        set: function (a) {
            var b = this.abp;
            if (a != b) {
                this.aa9 = a;
                this.sc("XAxisMajorStroke", b, this.abp);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "abw", {
        get: function () {
            return this.abg;
        },
        set: function (a) {
            var b = this.abw;
            if (a != b) {
                this.abg = a;
                this.sc("YAxisMajorStroke", b, this.abw);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "w3", {
        get: function () {
            return this.v1;
        },
        set: function (a) {
            var b = this.w3;
            if (a != b) {
                this.v1 = a;
                this.sc("XAxisMajorStrokeThickness", b, this.w3);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xk", {
        get: function () {
            return this.wi;
        },
        set: function (a) {
            var b = this.xk;
            if (a != b) {
                this.wi = a;
                this.sc("YAxisMajorStrokeThickness", b, this.xk);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "w4", {
        get: function () {
            return this.v2;
        },
        set: function (a) {
            var b = this.w4;
            if (a != b) {
                this.v2 = a;
                this.sc("XAxisMinorStrokeThickness", b, this.w4);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xl", {
        get: function () {
            return this.wj;
        },
        set: function (a) {
            var b = this.xl;
            if (a != b) {
                this.wj = a;
                this.sc("YAxisMinorStrokeThickness", b, this.xl);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "abr", {
        get: function () {
            return this.abb;
        },
        set: function (a) {
            var b = this.abr;
            if (a != b) {
                this.abb = a;
                this.sc("XAxisStrip", b, this.abr);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aby", {
        get: function () {
            return this.abi;
        },
        set: function (a) {
            var b = this.aby;
            if (a != b) {
                this.abi = a;
                this.sc("YAxisStrip", b, this.aby);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "abs", {
        get: function () {
            return this.abc;
        },
        set: function (a) {
            var b = this.abs;
            if (a != b) {
                this.abc = a;
                this.sc("XAxisStroke", b, this.abs);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "abz", {
        get: function () {
            return this.abj;
        },
        set: function (a) {
            var b = this.abz;
            if (a != b) {
                this.abj = a;
                this.sc("YAxisStroke", b, this.abz);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "w5", {
        get: function () {
            return this.v3;
        },
        set: function (a) {
            var b = this.w5;
            if (a != b) {
                this.v3 = a;
                this.sc("XAxisStrokeThickness", b, this.w5);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xm", {
        get: function () {
            return this.wk;
        },
        set: function (a) {
            var b = this.xm;
            if (a != b) {
                this.wk = a;
                this.sc("YAxisStrokeThickness", b, this.xm);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "w6", {
        get: function () {
            return this.v4;
        },
        set: function (a) {
            var b = this.w6;
            if (a != b) {
                this.v4 = a;
                this.sc("XAxisTickLength", b, this.w6);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xn", {
        get: function () {
            return this.wl;
        },
        set: function (a) {
            var b = this.xn;
            if (a != b) {
                this.wl = a;
                this.sc("YAxisTickLength", b, this.xn);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "abt", {
        get: function () {
            return this.abd;
        },
        set: function (a) {
            var b = this.abt;
            if (a != b) {
                this.abd = a;
                this.sc("XAxisTickStroke", b, this.abt);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ab0", {
        get: function () {
            return this.abk;
        },
        set: function (a) {
            var b = this.ab0;
            if (a != b) {
                this.abk = a;
                this.sc("YAxisTickStroke", b, this.ab0);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "w7", {
        get: function () {
            return this.v5;
        },
        set: function (a) {
            var b = this.w7;
            if (a != b) {
                this.v5 = a;
                this.sc("XAxisTickStrokeThickness", b, this.w7);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xo", {
        get: function () {
            return this.wm;
        },
        set: function (a) {
            var b = this.xo;
            if (a != b) {
                this.wm = a;
                this.sc("YAxisTickStrokeThickness", b, this.xo);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "y3", {
        get: function () {
            return this.x1;
        },
        set: function (a) {
            var b = this.y3;
            if (a != b) {
                this.x1 = a;
                this.sc("XAxisTitle", b, this.y3);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "z8", {
        get: function () {
            return this.x5;
        },
        set: function (a) {
            var b = this.z8;
            if (a != b) {
                this.x5 = a;
                this.sc("YAxisTitle", b, this.z8);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "abq", {
        get: function () {
            return this.aba;
        },
        set: function (a) {
            var b = this.abq;
            if (a != b) {
                this.aba = a;
                this.sc("XAxisMinorStroke", b, this.abq);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "abx", {
        get: function () {
            return this.abh;
        },
        set: function (a) {
            var b = this.abx;
            if (a != b) {
                this.abh = a;
                this.sc("YAxisMinorStroke", b, this.abx);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "wy", {
        get: function () {
            return this.vw;
        },
        set: function (a) {
            var b = this.wy;
            if (a != b) {
                this.vw = a;
                this.sc("XAxisLabelAngle", b, this.wy);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xf", {
        get: function () {
            return this.wd;
        },
        set: function (a) {
            var b = this.xf;
            if (a != b) {
                this.wd = a;
                this.sc("YAxisLabelAngle", b, this.xf);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "wx", {
        get: function () {
            return this.vv;
        },
        set: function (a) {
            var b = this.wx;
            if (a != b) {
                this.vv = a;
                this.sc("XAxisExtent", b, this.wx);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xe", {
        get: function () {
            return this.wc;
        },
        set: function (a) {
            var b = this.xe;
            if (a != b) {
                this.wc = a;
                this.sc("YAxisExtent", b, this.xe);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "w8", {
        get: function () {
            return this.v6;
        },
        set: function (a) {
            var b = this.w8;
            if (a != b) {
                this.v6 = a;
                this.sc("XAxisTitleAngle", b, this.w8);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "xp", {
        get: function () {
            return this.wn;
        },
        set: function (a) {
            var b = this.xp;
            if (a != b) {
                this.wn = a;
                this.sc("YAxisTitleAngle", b, this.xp);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "vt", {
        get: function () {
            return this.vr;
        },
        set: function (a) {
            var b = this.vt;
            if (a != b) {
                this.vr = a;
                this.sc("XAxisInverted", b, this.vt);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "vu", {
        get: function () {
            return this.vs;
        },
        set: function (a) {
            var b = this.vu;
            if (a != b) {
                this.vs = a;
                this.sc("YAxisInverted", b, this.vu);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aa4", {
        get: function () {
            return this.aa1;
        },
        set: function (a) {
            var b = this.aa4;
            if (a != b) {
                this.aa1 = a;
                this.sc("XAxisTitleAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.aa4));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ab7", {
        get: function () {
            return this.ab4;
        },
        set: function (a) {
            var b = this.ab7;
            if (a != b) {
                this.ab4 = a;
                this.sc("YAxisTitleAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.ab7));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aa3", {
        get: function () {
            return this.aa0;
        },
        set: function (a) {
            var b = this.aa3;
            if (a != b) {
                this.aa0 = a;
                this.sc("XAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.aa3));
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.get_aa5 = function () {
        return this.aa2;
    };
    XYChart.prototype.set_aa5 = function (a) {
        var b = this.aa5;
        if (a != b) {
            this.aa2 = a;
            this.sc("YAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.aa5));
        }
    };
    Object.defineProperty(XYChart.prototype, "aa5", {
        get: function () {
            return this.get_aa5();
        },
        set: function (a) {
            this.set_aa5(a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ab5", {
        get: function () {
            return this.ab2;
        },
        set: function (a) {
            var b = this.ab5;
            if (a != b) {
                this.ab2 = a;
                this.sc("XAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.ab5));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ab6", {
        get: function () {
            return this.ab3;
        },
        set: function (a) {
            var b = this.ab6;
            if (a != b) {
                this.ab3 = a;
                this.sc("YAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.ab6));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "aca", {
        get: function () {
            return this.ab8;
        },
        set: function (a) {
            var b = this.aca;
            if (a != b) {
                this.ab8 = a;
                this.sc("XAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.aca));
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "acb", {
        get: function () {
            return this.ab9;
        },
        set: function (a) {
            var b = this.acb;
            if (a != b) {
                this.ab9 = a;
                this.sc("YAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.acb));
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.get_vq = function () {
        return this.vp;
    };
    XYChart.prototype.set_vq = function (a) {
        var b = this.vq;
        if (a != b) {
            this.vp = a;
            this.sc("YAxisLabelLocation", enumGetBox(YAxisLabelLocation_$type, b), enumGetBox(YAxisLabelLocation_$type, this.vq));
        }
    };
    Object.defineProperty(XYChart.prototype, "vq", {
        get: function () {
            return this.get_vq();
        },
        set: function (a) {
            this.set_vq(a);
        },
        enumerable: false,
        configurable: true
    });
    XYChart.prototype.get_vo = function () {
        return this.vn;
    };
    XYChart.prototype.set_vo = function (a) {
        var b = this.vo;
        if (a != b) {
            this.vn = a;
            this.sc("XAxisLabelLocation", enumGetBox(XAxisLabelLocation_$type, b), enumGetBox(XAxisLabelLocation_$type, this.vo));
        }
    };
    Object.defineProperty(XYChart.prototype, "vo", {
        get: function () {
            return this.get_vo();
        },
        set: function (a) {
            this.set_vo(a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "yf", {
        get: function () {
            return this.xz;
        },
        set: function (a) {
            var b = this.xz;
            if (a != b) {
                this.xz = a;
                this.sc("XAxisLabelFormat", b, this.xz);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "vd", {
        get: function () {
            return this.vb;
        },
        set: function (a) {
            var b = this.vb;
            if (a != b) {
                this.vb = a;
                this.sc("XAxisLabelFormatSpecifiers", b, this.vb);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "zk", {
        get: function () {
            return this.x3;
        },
        set: function (a) {
            var b = this.x3;
            if (a != b) {
                this.x3 = a;
                this.sc("YAxisLabelFormat", b, this.x3);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(XYChart.prototype, "ve", {
        get: function () {
            return this.vc;
        },
        set: function (a) {
            var b = this.vc;
            if (a != b) {
                this.vc = a;
                this.sc("YAxisLabelFormatSpecifiers", b, this.vc);
            }
        },
        enumerable: false,
        configurable: true
    });
    XYChart.$t = markType(XYChart, 'XYChart', DomainChart.$);
    return XYChart;
}(DomainChart));
export { XYChart };
