import { DomainChart } from "./DomainChart";
import { IEnumerable$1, Type } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { HorizontalAlignment } from "igniteui-react-core";
import { VerticalAlignment } from "igniteui-react-core";
import { Visibility } from "igniteui-react-core";
import { YAxisLabelLocation } from "./YAxisLabelLocation";
import { XAxisLabelLocation } from "./XAxisLabelLocation";
import { Axis } from "./Axis";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { TitleSettings } from "./TitleSettings";
import { DataSeries } from "igniteui-react-core";
import { XamDataChart } from "./XamDataChart";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { AxisLabelsLocation } from "./AxisLabelsLocation";
/**
 * @hidden
 */
export declare abstract class XYChart extends DomainChart {
    static $t: Type;
    provideContainer(a: any): void;
    protected rq(): void;
    protected sd(a: string, b: any, c: any): void;
    private vh;
    get vj(): (item: any) => string;
    set vj(a: (item: any) => string);
    private vi;
    get vk(): (item: any) => string;
    set vk(a: (item: any) => string);
    private vy;
    get w0(): number;
    set w0(a: number);
    private v0;
    get w2(): number;
    set w2(a: number);
    private vz;
    get w1(): number;
    set w1(a: number);
    private vx;
    get wz(): number;
    set wz(a: number);
    private wf;
    get xh(): number;
    set xh(a: number);
    private wh;
    get xj(): number;
    set xj(a: number);
    private wg;
    get xi(): number;
    set xi(a: number);
    private we;
    get xg(): number;
    set xg(a: number);
    private aa8;
    get abo(): Brush;
    set abo(a: Brush);
    private abf;
    get abv(): Brush;
    set abv(a: Brush);
    private aa6;
    get abm(): Brush;
    set abm(a: Brush);
    private aa7;
    get abn(): Brush;
    set abn(a: Brush);
    private v9;
    get xb(): number;
    set xb(a: number);
    private wq;
    get xs(): number;
    set xs(a: number);
    private v8;
    get xa(): number;
    set xa(a: number);
    private wp;
    get xr(): number;
    set xr(a: number);
    private wb;
    get xd(): number;
    set xd(a: number);
    private ws;
    get xu(): number;
    set xu(a: number);
    private wa;
    get xc(): number;
    set xc(a: number);
    private wr;
    get xt(): number;
    set xt(a: number);
    private v7;
    get w9(): number;
    set w9(a: number);
    private wo;
    get xq(): number;
    set xq(a: number);
    private abe;
    get abu(): Brush;
    set abu(a: Brush);
    private abl;
    get ab1(): Brush;
    set ab1(a: Brush);
    protected se(a: string, b: any, c: any): void;
    private x0;
    get yo(): string;
    set yo(a: string);
    private x4;
    get zt(): string;
    set zt(a: string);
    private x2;
    get zc(): string;
    set zc(a: string);
    private x6;
    get aah(): string;
    set aah(a: string);
    private aan;
    private aap;
    protected sv(a: DataSeries): void;
    protected abstract vf(): Axis;
    protected abstract vg(): Axis;
    protected aaq(a: (arg1: Axis) => void): void;
    protected aar(a: (arg1: Axis) => void, b: string): void;
    protected aaw(a: (arg1: Axis) => void, b: boolean): void;
    protected aav(a: (arg1: Axis) => void): void;
    protected ra(a: (arg1: Axis) => void, b: boolean): void;
    protected aau(a: (arg1: TitleSettings) => void): void;
    protected aaz(a: (arg1: TitleSettings) => void): void;
    protected aax(a: (arg1: AxisLabelSettings) => void): void;
    protected aas(a: (arg1: AxisLabelSettings) => void): void;
    wt(a: number): number;
    wv(a: number): number;
    wu(a: number): number;
    ww(a: number): number;
    protected ss(a: XamDataChart): void;
    static x9(a: CategoryAxisBase, b: IEnumerable$1<DataSeries>): string;
    protected rl(a: XamDataChart): void;
    protected aam(a: Axis): void;
    protected aao(a: Axis): void;
    protected ri(): void;
    protected aak(a: Axis, b: (arg1: AxisLabelSettings) => void): void;
    protected aal(a: Axis, b: (arg1: TitleSettings) => void): void;
    protected sc(a: string, b: any, c: any): void;
    aay(): void;
    aat(): void;
    vm(a: YAxisLabelLocation): AxisLabelsLocation;
    vl(a: XAxisLabelLocation): AxisLabelsLocation;
    private xv;
    get xx(): any;
    set xx(a: any);
    private xw;
    get xy(): any;
    set xy(a: any);
    private aa9;
    get abp(): Brush;
    set abp(a: Brush);
    private abg;
    get abw(): Brush;
    set abw(a: Brush);
    private v1;
    get w3(): number;
    set w3(a: number);
    private wi;
    get xk(): number;
    set xk(a: number);
    private v2;
    get w4(): number;
    set w4(a: number);
    private wj;
    get xl(): number;
    set xl(a: number);
    private abb;
    get abr(): Brush;
    set abr(a: Brush);
    private abi;
    get aby(): Brush;
    set aby(a: Brush);
    private abc;
    get abs(): Brush;
    set abs(a: Brush);
    private abj;
    get abz(): Brush;
    set abz(a: Brush);
    private v3;
    get w5(): number;
    set w5(a: number);
    private wk;
    get xm(): number;
    set xm(a: number);
    private v4;
    get w6(): number;
    set w6(a: number);
    private wl;
    get xn(): number;
    set xn(a: number);
    private abd;
    get abt(): Brush;
    set abt(a: Brush);
    private abk;
    get ab0(): Brush;
    set ab0(a: Brush);
    private v5;
    get w7(): number;
    set w7(a: number);
    private wm;
    get xo(): number;
    set xo(a: number);
    private x1;
    get y3(): string;
    set y3(a: string);
    private x5;
    get z8(): string;
    set z8(a: string);
    private aba;
    get abq(): Brush;
    set abq(a: Brush);
    private abh;
    get abx(): Brush;
    set abx(a: Brush);
    private vw;
    get wy(): number;
    set wy(a: number);
    private wd;
    get xf(): number;
    set xf(a: number);
    private vv;
    get wx(): number;
    set wx(a: number);
    private wc;
    get xe(): number;
    set xe(a: number);
    private v6;
    get w8(): number;
    set w8(a: number);
    private wn;
    get xp(): number;
    set xp(a: number);
    private vr;
    get vt(): boolean;
    set vt(a: boolean);
    private vs;
    get vu(): boolean;
    set vu(a: boolean);
    private aa1;
    get aa4(): HorizontalAlignment;
    set aa4(a: HorizontalAlignment);
    private ab4;
    get ab7(): VerticalAlignment;
    set ab7(a: VerticalAlignment);
    private aa0;
    get aa3(): HorizontalAlignment;
    set aa3(a: HorizontalAlignment);
    private aa2;
    protected get_aa5(): HorizontalAlignment;
    protected set_aa5(a: HorizontalAlignment): void;
    get aa5(): HorizontalAlignment;
    set aa5(a: HorizontalAlignment);
    private ab2;
    get ab5(): VerticalAlignment;
    set ab5(a: VerticalAlignment);
    private ab3;
    get ab6(): VerticalAlignment;
    set ab6(a: VerticalAlignment);
    private ab8;
    get aca(): Visibility;
    set aca(a: Visibility);
    private ab9;
    get acb(): Visibility;
    set acb(a: Visibility);
    private vp;
    protected get_vq(): YAxisLabelLocation;
    protected set_vq(a: YAxisLabelLocation): void;
    get vq(): YAxisLabelLocation;
    set vq(a: YAxisLabelLocation);
    private vn;
    protected get_vo(): XAxisLabelLocation;
    protected set_vo(a: XAxisLabelLocation): void;
    get vo(): XAxisLabelLocation;
    set vo(a: XAxisLabelLocation);
    private xz;
    get yf(): string;
    set yf(a: string);
    private vb;
    get vd(): any[];
    set vd(a: any[]);
    private x3;
    get zk(): string;
    set zk(a: string);
    private vc;
    get ve(): any[];
    set ve(a: any[]);
}
